/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 25 "ircd_parser.y"


#define YY_NO_UNPUT
#include <sys/types.h>
#include <libgen.h>

#include "stdinc.h"
#include "ircd.h"
#include "tools.h"
#include "list.h"
#include "s_conf.h"
#include "event.h"
#include "s_log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "pcre.h"
#include "irc_string.h"
#include "irc_getaddrinfo.h"
#include "sprintf_irc.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h" /* for CAP_LL / IsCapable */
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "s_misc.h"

#ifdef HAVE_LIBCRYPTO
#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#endif

static char *class_name = NULL;
static struct ConfItem *yy_conf = NULL;
static struct AccessItem *yy_aconf = NULL;
static struct MatchItem *yy_match_item = NULL;
static struct ClassItem *yy_class = NULL;
static char *yy_class_name = NULL;

static dlink_list col_conf_list  = { NULL, NULL, 0 };
static dlink_list hub_conf_list  = { NULL, NULL, 0 };
static dlink_list leaf_conf_list = { NULL, NULL, 0 };
static unsigned int listener_flags = 0;
static unsigned int regex_ban = 0;
static char userbuf[IRCD_BUFSIZE];
static char hostbuf[IRCD_BUFSIZE];
static char reasonbuf[REASONLEN + 1];
static char gecos_name[REALLEN * 4];

extern dlink_list gdeny_items; /* XXX */

static char *resv_reason = NULL;
static char *listener_address = NULL;
static int not_atom = 0;

struct CollectItem
{
  dlink_node node;
  char *name;
  char *user;
  char *host;
  char *passwd;
  int  port;
  int  flags;
#ifdef HAVE_LIBCRYPTO
  char *rsa_public_key_file;
  RSA *rsa_public_key;
#endif
};

static void
free_collect_item(struct CollectItem *item)
{
  MyFree(item->name);
  MyFree(item->user);
  MyFree(item->host);
  MyFree(item->passwd);
#ifdef HAVE_LIBCRYPTO
  MyFree(item->rsa_public_key_file);
#endif
  MyFree(item);
}

static void
unhook_hub_leaf_confs(void)
{
  dlink_node *ptr;
  dlink_node *next_ptr;
  struct CollectItem *yy_hconf;
  struct CollectItem *yy_lconf;

  DLINK_FOREACH_SAFE(ptr, next_ptr, hub_conf_list.head)
  {
    yy_hconf = ptr->data;
    dlinkDelete(&yy_hconf->node, &hub_conf_list);
    free_collect_item(yy_hconf);
  }

  DLINK_FOREACH_SAFE(ptr, next_ptr, leaf_conf_list.head)
  {
    yy_lconf = ptr->data;
    dlinkDelete(&yy_lconf->node, &leaf_conf_list);
    free_collect_item(yy_lconf);
  }
}


/* Line 371 of yacc.c  */
#line 179 "ircd_parser.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACCEPT_PASSWORD = 258,
     ACTION = 259,
     ADMIN = 260,
     AFTYPE = 261,
     T_ALLOW = 262,
     ANTI_NICK_FLOOD = 263,
     ANTI_SPAM_EXIT_MESSAGE_TIME = 264,
     AUTOCONN = 265,
     T_BLOCK = 266,
     BURST_AWAY = 267,
     BURST_TOPICWHO = 268,
     BYTES = 269,
     KBYTES = 270,
     MBYTES = 271,
     GBYTES = 272,
     TBYTES = 273,
     CALLER_ID_WAIT = 274,
     CAN_FLOOD = 275,
     CAN_IDLE = 276,
     CHANNEL = 277,
     CIDR_BITLEN_IPV4 = 278,
     CIDR_BITLEN_IPV6 = 279,
     CIPHER_PREFERENCE = 280,
     CLASS = 281,
     COMPRESSED = 282,
     COMPRESSION_LEVEL = 283,
     CONNECT = 284,
     CONNECTFREQ = 285,
     CRYPTLINK = 286,
     DEFAULT_CIPHER_PREFERENCE = 287,
     DEFAULT_FLOODCOUNT = 288,
     DEFAULT_SPLIT_SERVER_COUNT = 289,
     DEFAULT_SPLIT_USER_COUNT = 290,
     DENY = 291,
     DESCRIPTION = 292,
     DIE = 293,
     DISABLE_AUTH = 294,
     DISABLE_FAKE_CHANNELS = 295,
     DISABLE_HIDDEN = 296,
     DISABLE_LOCAL_CHANNELS = 297,
     DISABLE_REMOTE_COMMANDS = 298,
     DOT_IN_IP6_ADDR = 299,
     DOTS_IN_IDENT = 300,
     DURATION = 301,
     EGDPOOL_PATH = 302,
     EMAIL = 303,
     ENABLE = 304,
     ENCRYPTED = 305,
     EXCEED_LIMIT = 306,
     EXEMPT = 307,
     FAILED_OPER_NOTICE = 308,
     FAKENAME = 309,
     IRCD_FLAGS = 310,
     FLATTEN_LINKS = 311,
     FFAILED_OPERLOG = 312,
     FKILLLOG = 313,
     FKLINELOG = 314,
     FGLINELOG = 315,
     FIOERRLOG = 316,
     FOPERLOG = 317,
     FOPERSPYLOG = 318,
     FUSERLOG = 319,
     GECOS = 320,
     GENERAL = 321,
     GLINE = 322,
     GLINES = 323,
     GLINE_EXEMPT = 324,
     GLINE_LOG = 325,
     GLINE_TIME = 326,
     GLINE_MIN_CIDR = 327,
     GLINE_MIN_CIDR6 = 328,
     GLOBAL_KILL = 329,
     GODMODE_TIMEOUT = 330,
     IRCD_AUTH = 331,
     NEED_IDENT = 332,
     HAVENT_READ_CONF = 333,
     HIDDEN = 334,
     HIDDEN_ADMIN = 335,
     HIDDEN_NAME = 336,
     HIDDEN_OPER = 337,
     HIDE_SERVER_IPS = 338,
     HIDE_SERVERS = 339,
     HIDE_SPOOF_IPS = 340,
     HOST = 341,
     HUB = 342,
     HUB_MASK = 343,
     CLIENTCERT_HASH = 344,
     IDLETIME = 345,
     IGNORE_BOGUS_TS = 346,
     INVISIBLE_ON_CONNECT = 347,
     IP = 348,
     KILL = 349,
     KILL_CHASE_TIME_LIMIT = 350,
     KLINE = 351,
     KLINE_EXEMPT = 352,
     KLINE_REASON = 353,
     KLINE_WITH_REASON = 354,
     KNOCK_DELAY = 355,
     KNOCK_DELAY_CHANNEL = 356,
     LAZYLINK = 357,
     LEAF_MASK = 358,
     LINKS_DELAY = 359,
     LISTEN = 360,
     T_LOG = 361,
     LOGGING = 362,
     LOG_LEVEL = 363,
     MAX_ACCEPT = 364,
     MAX_BANS = 365,
     MAX_CHANS_PER_USER = 366,
     MAX_GLOBAL = 367,
     MAX_IDENT = 368,
     MAX_LOCAL = 369,
     MAX_NICK_CHANGES = 370,
     MAX_NICK_TIME = 371,
     MAX_NUMBER = 372,
     MAX_TARGETS = 373,
     MESSAGE_LOCALE = 374,
     MIN_NONWILDCARD = 375,
     MIN_NONWILDCARD_SIMPLE = 376,
     MODULE = 377,
     MODULES = 378,
     NAME = 379,
     NEED_PASSWORD = 380,
     NETWORK_DESC = 381,
     NETWORK_NAME = 382,
     NICK = 383,
     NICK_CHANGES = 384,
     NO_CREATE_ON_SPLIT = 385,
     NO_JOIN_ON_SPLIT = 386,
     NO_OPER_FLOOD = 387,
     NO_TILDE = 388,
     NOT = 389,
     NUMBER = 390,
     NUMBER_PER_IDENT = 391,
     NUMBER_PER_CIDR = 392,
     NUMBER_PER_IP = 393,
     NUMBER_PER_IP_GLOBAL = 394,
     OPERATOR = 395,
     OPERS_BYPASS_CALLERID = 396,
     OPER_LOG = 397,
     OPER_ONLY_UMODES = 398,
     OPER_PASS_RESV = 399,
     OPER_SPY_T = 400,
     OPER_UMODES = 401,
     JOIN_FLOOD_COUNT = 402,
     JOIN_FLOOD_TIME = 403,
     PACE_WAIT = 404,
     PACE_WAIT_SIMPLE = 405,
     PASSWORD = 406,
     PATH = 407,
     PING_COOKIE = 408,
     PING_TIME = 409,
     PING_WARNING = 410,
     PORT = 411,
     QSTRING = 412,
     QUIET_ON_BAN = 413,
     REASON = 414,
     REDIRPORT = 415,
     REDIRSERV = 416,
     REGEX_T = 417,
     REHASH = 418,
     TREJECT_HOLD_TIME = 419,
     REMOTE = 420,
     REMOTEBAN = 421,
     REJECT_MESSAGE = 422,
     RESTRICT_CHANNELS = 423,
     RESTRICTED = 424,
     RSA_PRIVATE_KEY_FILE = 425,
     RSA_PUBLIC_KEY_FILE = 426,
     SSL_CERTIFICATE_FILE = 427,
     RESV = 428,
     RESV_EXEMPT = 429,
     SECONDS = 430,
     MINUTES = 431,
     HOURS = 432,
     DAYS = 433,
     WEEKS = 434,
     SENDQ = 435,
     SEND_PASSWORD = 436,
     SERVERHIDE = 437,
     SERVERINFO = 438,
     SERVLINK_PATH = 439,
     IRCD_SID = 440,
     TKLINE_EXPIRE_NOTICES = 441,
     T_SHARED = 442,
     T_CLUSTER = 443,
     TYPE = 444,
     SHORT_MOTD = 445,
     SILENT = 446,
     SPOOF = 447,
     SPOOF_NOTICE = 448,
     STATS_E_DISABLED = 449,
     STATS_I_OPER_ONLY = 450,
     STATS_K_OPER_ONLY = 451,
     STATS_O_OPER_ONLY = 452,
     STATS_P_OPER_ONLY = 453,
     TBOOL = 454,
     TMASKED = 455,
     T_REJECT = 456,
     TS_MAX_DELTA = 457,
     TS_WARN_DELTA = 458,
     TWODOTS = 459,
     T_ALL = 460,
     T_BOTS = 461,
     T_SOFTCALLERID = 462,
     T_CALLERID = 463,
     T_CCONN = 464,
     T_CCONN_FULL = 465,
     T_CLIENT_FLOOD = 466,
     T_DEAF = 467,
     T_DEBUG = 468,
     T_DRONE = 469,
     T_EXTERNAL = 470,
     T_FULL = 471,
     T_INVISIBLE = 472,
     T_IPV4 = 473,
     T_IPV6 = 474,
     T_LOCOPS = 475,
     T_LOGPATH = 476,
     T_L_CRIT = 477,
     T_L_DEBUG = 478,
     T_L_ERROR = 479,
     T_L_INFO = 480,
     T_L_NOTICE = 481,
     T_L_TRACE = 482,
     T_L_WARN = 483,
     T_MAX_CLIENTS = 484,
     T_NCHANGE = 485,
     T_OPERWALL = 486,
     T_REJ = 487,
     T_SERVER = 488,
     T_SERVNOTICE = 489,
     T_SKILL = 490,
     T_SPY = 491,
     T_SSL = 492,
     T_UMODES = 493,
     T_UNAUTH = 494,
     T_UNRESV = 495,
     T_UNXLINE = 496,
     T_WALLOP = 497,
     T_GOD = 498,
     T_NICKSERVREG = 499,
     THROTTLE_TIME = 500,
     TOPICBURST = 501,
     TRUE_NO_OPER_FLOOD = 502,
     TKLINE = 503,
     TXLINE = 504,
     TRESV = 505,
     UNKLINE = 506,
     USER = 507,
     USE_EGD = 508,
     USE_EXCEPT = 509,
     USE_INVEX = 510,
     USE_QUIET = 511,
     USE_KNOCK = 512,
     USE_LOGGING = 513,
     USE_WHOIS_ACTUALLY = 514,
     VHOST = 515,
     VHOST6 = 516,
     XLINE = 517,
     WARN = 518,
     WARN_NO_NLINE = 519
   };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACTION 259
#define ADMIN 260
#define AFTYPE 261
#define T_ALLOW 262
#define ANTI_NICK_FLOOD 263
#define ANTI_SPAM_EXIT_MESSAGE_TIME 264
#define AUTOCONN 265
#define T_BLOCK 266
#define BURST_AWAY 267
#define BURST_TOPICWHO 268
#define BYTES 269
#define KBYTES 270
#define MBYTES 271
#define GBYTES 272
#define TBYTES 273
#define CALLER_ID_WAIT 274
#define CAN_FLOOD 275
#define CAN_IDLE 276
#define CHANNEL 277
#define CIDR_BITLEN_IPV4 278
#define CIDR_BITLEN_IPV6 279
#define CIPHER_PREFERENCE 280
#define CLASS 281
#define COMPRESSED 282
#define COMPRESSION_LEVEL 283
#define CONNECT 284
#define CONNECTFREQ 285
#define CRYPTLINK 286
#define DEFAULT_CIPHER_PREFERENCE 287
#define DEFAULT_FLOODCOUNT 288
#define DEFAULT_SPLIT_SERVER_COUNT 289
#define DEFAULT_SPLIT_USER_COUNT 290
#define DENY 291
#define DESCRIPTION 292
#define DIE 293
#define DISABLE_AUTH 294
#define DISABLE_FAKE_CHANNELS 295
#define DISABLE_HIDDEN 296
#define DISABLE_LOCAL_CHANNELS 297
#define DISABLE_REMOTE_COMMANDS 298
#define DOT_IN_IP6_ADDR 299
#define DOTS_IN_IDENT 300
#define DURATION 301
#define EGDPOOL_PATH 302
#define EMAIL 303
#define ENABLE 304
#define ENCRYPTED 305
#define EXCEED_LIMIT 306
#define EXEMPT 307
#define FAILED_OPER_NOTICE 308
#define FAKENAME 309
#define IRCD_FLAGS 310
#define FLATTEN_LINKS 311
#define FFAILED_OPERLOG 312
#define FKILLLOG 313
#define FKLINELOG 314
#define FGLINELOG 315
#define FIOERRLOG 316
#define FOPERLOG 317
#define FOPERSPYLOG 318
#define FUSERLOG 319
#define GECOS 320
#define GENERAL 321
#define GLINE 322
#define GLINES 323
#define GLINE_EXEMPT 324
#define GLINE_LOG 325
#define GLINE_TIME 326
#define GLINE_MIN_CIDR 327
#define GLINE_MIN_CIDR6 328
#define GLOBAL_KILL 329
#define GODMODE_TIMEOUT 330
#define IRCD_AUTH 331
#define NEED_IDENT 332
#define HAVENT_READ_CONF 333
#define HIDDEN 334
#define HIDDEN_ADMIN 335
#define HIDDEN_NAME 336
#define HIDDEN_OPER 337
#define HIDE_SERVER_IPS 338
#define HIDE_SERVERS 339
#define HIDE_SPOOF_IPS 340
#define HOST 341
#define HUB 342
#define HUB_MASK 343
#define CLIENTCERT_HASH 344
#define IDLETIME 345
#define IGNORE_BOGUS_TS 346
#define INVISIBLE_ON_CONNECT 347
#define IP 348
#define KILL 349
#define KILL_CHASE_TIME_LIMIT 350
#define KLINE 351
#define KLINE_EXEMPT 352
#define KLINE_REASON 353
#define KLINE_WITH_REASON 354
#define KNOCK_DELAY 355
#define KNOCK_DELAY_CHANNEL 356
#define LAZYLINK 357
#define LEAF_MASK 358
#define LINKS_DELAY 359
#define LISTEN 360
#define T_LOG 361
#define LOGGING 362
#define LOG_LEVEL 363
#define MAX_ACCEPT 364
#define MAX_BANS 365
#define MAX_CHANS_PER_USER 366
#define MAX_GLOBAL 367
#define MAX_IDENT 368
#define MAX_LOCAL 369
#define MAX_NICK_CHANGES 370
#define MAX_NICK_TIME 371
#define MAX_NUMBER 372
#define MAX_TARGETS 373
#define MESSAGE_LOCALE 374
#define MIN_NONWILDCARD 375
#define MIN_NONWILDCARD_SIMPLE 376
#define MODULE 377
#define MODULES 378
#define NAME 379
#define NEED_PASSWORD 380
#define NETWORK_DESC 381
#define NETWORK_NAME 382
#define NICK 383
#define NICK_CHANGES 384
#define NO_CREATE_ON_SPLIT 385
#define NO_JOIN_ON_SPLIT 386
#define NO_OPER_FLOOD 387
#define NO_TILDE 388
#define NOT 389
#define NUMBER 390
#define NUMBER_PER_IDENT 391
#define NUMBER_PER_CIDR 392
#define NUMBER_PER_IP 393
#define NUMBER_PER_IP_GLOBAL 394
#define OPERATOR 395
#define OPERS_BYPASS_CALLERID 396
#define OPER_LOG 397
#define OPER_ONLY_UMODES 398
#define OPER_PASS_RESV 399
#define OPER_SPY_T 400
#define OPER_UMODES 401
#define JOIN_FLOOD_COUNT 402
#define JOIN_FLOOD_TIME 403
#define PACE_WAIT 404
#define PACE_WAIT_SIMPLE 405
#define PASSWORD 406
#define PATH 407
#define PING_COOKIE 408
#define PING_TIME 409
#define PING_WARNING 410
#define PORT 411
#define QSTRING 412
#define QUIET_ON_BAN 413
#define REASON 414
#define REDIRPORT 415
#define REDIRSERV 416
#define REGEX_T 417
#define REHASH 418
#define TREJECT_HOLD_TIME 419
#define REMOTE 420
#define REMOTEBAN 421
#define REJECT_MESSAGE 422
#define RESTRICT_CHANNELS 423
#define RESTRICTED 424
#define RSA_PRIVATE_KEY_FILE 425
#define RSA_PUBLIC_KEY_FILE 426
#define SSL_CERTIFICATE_FILE 427
#define RESV 428
#define RESV_EXEMPT 429
#define SECONDS 430
#define MINUTES 431
#define HOURS 432
#define DAYS 433
#define WEEKS 434
#define SENDQ 435
#define SEND_PASSWORD 436
#define SERVERHIDE 437
#define SERVERINFO 438
#define SERVLINK_PATH 439
#define IRCD_SID 440
#define TKLINE_EXPIRE_NOTICES 441
#define T_SHARED 442
#define T_CLUSTER 443
#define TYPE 444
#define SHORT_MOTD 445
#define SILENT 446
#define SPOOF 447
#define SPOOF_NOTICE 448
#define STATS_E_DISABLED 449
#define STATS_I_OPER_ONLY 450
#define STATS_K_OPER_ONLY 451
#define STATS_O_OPER_ONLY 452
#define STATS_P_OPER_ONLY 453
#define TBOOL 454
#define TMASKED 455
#define T_REJECT 456
#define TS_MAX_DELTA 457
#define TS_WARN_DELTA 458
#define TWODOTS 459
#define T_ALL 460
#define T_BOTS 461
#define T_SOFTCALLERID 462
#define T_CALLERID 463
#define T_CCONN 464
#define T_CCONN_FULL 465
#define T_CLIENT_FLOOD 466
#define T_DEAF 467
#define T_DEBUG 468
#define T_DRONE 469
#define T_EXTERNAL 470
#define T_FULL 471
#define T_INVISIBLE 472
#define T_IPV4 473
#define T_IPV6 474
#define T_LOCOPS 475
#define T_LOGPATH 476
#define T_L_CRIT 477
#define T_L_DEBUG 478
#define T_L_ERROR 479
#define T_L_INFO 480
#define T_L_NOTICE 481
#define T_L_TRACE 482
#define T_L_WARN 483
#define T_MAX_CLIENTS 484
#define T_NCHANGE 485
#define T_OPERWALL 486
#define T_REJ 487
#define T_SERVER 488
#define T_SERVNOTICE 489
#define T_SKILL 490
#define T_SPY 491
#define T_SSL 492
#define T_UMODES 493
#define T_UNAUTH 494
#define T_UNRESV 495
#define T_UNXLINE 496
#define T_WALLOP 497
#define T_GOD 498
#define T_NICKSERVREG 499
#define THROTTLE_TIME 500
#define TOPICBURST 501
#define TRUE_NO_OPER_FLOOD 502
#define TKLINE 503
#define TXLINE 504
#define TRESV 505
#define UNKLINE 506
#define USER 507
#define USE_EGD 508
#define USE_EXCEPT 509
#define USE_INVEX 510
#define USE_QUIET 511
#define USE_KNOCK 512
#define USE_LOGGING 513
#define USE_WHOIS_ACTUALLY 514
#define VHOST 515
#define VHOST6 516
#define XLINE 517
#define WARN 518
#define WARN_NO_NLINE 519



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 136 "ircd_parser.y"

  int number;
  char *string;


/* Line 387 of yacc.c  */
#line 756 "ircd_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 784 "ircd_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1437

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  270
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  347
/* YYNRULES -- Number of rules.  */
#define YYNRULES  750
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1512

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   519

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   269,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   265,
       2,   268,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   267,     2,   266,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    50,    53,    54,    56,    59,
      63,    67,    71,    75,    79,    80,    82,    85,    89,    93,
      97,   103,   106,   108,   110,   112,   115,   120,   125,   131,
     134,   136,   138,   140,   142,   144,   146,   148,   150,   152,
     154,   156,   158,   161,   166,   171,   176,   181,   186,   191,
     196,   201,   206,   211,   216,   222,   225,   227,   229,   231,
     233,   236,   241,   246,   251,   257,   260,   262,   264,   266,
     268,   270,   272,   274,   276,   278,   280,   282,   284,   286,
     289,   294,   299,   304,   309,   314,   319,   324,   329,   334,
     339,   344,   349,   354,   359,   364,   369,   374,   379,   380,
     388,   389,   391,   394,   396,   398,   400,   402,   404,   406,
     408,   410,   412,   414,   416,   418,   420,   422,   424,   426,
     428,   430,   432,   434,   436,   438,   440,   442,   445,   450,
     452,   457,   462,   467,   472,   477,   482,   483,   489,   493,
     495,   497,   499,   501,   503,   505,   507,   509,   511,   513,
     515,   517,   519,   521,   523,   525,   527,   529,   531,   533,
     535,   540,   545,   550,   555,   560,   565,   570,   575,   580,
     585,   590,   595,   600,   605,   606,   612,   616,   618,   619,
     623,   624,   627,   629,   631,   633,   635,   637,   639,   641,
     643,   645,   647,   649,   651,   653,   655,   657,   659,   660,
     668,   669,   671,   674,   676,   678,   680,   682,   684,   686,
     688,   690,   692,   694,   696,   698,   700,   702,   704,   707,
     712,   714,   719,   724,   729,   734,   739,   744,   749,   754,
     759,   764,   769,   774,   779,   780,   787,   788,   794,   798,
     800,   802,   804,   806,   809,   811,   813,   815,   817,   819,
     822,   823,   829,   833,   835,   837,   841,   846,   851,   852,
     859,   862,   864,   866,   868,   870,   872,   874,   876,   878,
     880,   882,   884,   886,   888,   890,   892,   894,   896,   898,
     901,   906,   911,   916,   921,   926,   931,   932,   938,   942,
     944,   945,   949,   950,   953,   955,   957,   959,   961,   963,
     965,   967,   969,   971,   973,   978,   983,   988,   993,   998,
    1003,  1008,  1013,  1018,  1023,  1024,  1031,  1034,  1036,  1038,
    1040,  1042,  1045,  1050,  1055,  1060,  1061,  1068,  1071,  1073,
    1075,  1077,  1079,  1082,  1087,  1092,  1093,  1099,  1103,  1105,
    1107,  1109,  1111,  1113,  1115,  1117,  1119,  1121,  1123,  1125,
    1127,  1128,  1135,  1138,  1140,  1142,  1144,  1147,  1152,  1153,
    1159,  1163,  1165,  1167,  1169,  1171,  1173,  1175,  1177,  1179,
    1181,  1183,  1185,  1187,  1188,  1196,  1197,  1199,  1202,  1204,
    1206,  1208,  1210,  1212,  1214,  1216,  1218,  1220,  1222,  1224,
    1226,  1228,  1230,  1232,  1234,  1236,  1238,  1240,  1242,  1245,
    1250,  1252,  1257,  1262,  1267,  1272,  1277,  1282,  1287,  1292,
    1293,  1299,  1303,  1305,  1306,  1310,  1311,  1314,  1316,  1318,
    1320,  1322,  1324,  1326,  1331,  1336,  1341,  1346,  1351,  1356,
    1361,  1366,  1371,  1376,  1377,  1384,  1385,  1391,  1395,  1397,
    1399,  1402,  1404,  1406,  1408,  1410,  1412,  1417,  1422,  1423,
    1430,  1433,  1435,  1437,  1439,  1441,  1446,  1451,  1457,  1460,
    1462,  1464,  1466,  1468,  1473,  1478,  1479,  1486,  1487,  1493,
    1497,  1499,  1501,  1504,  1506,  1508,  1510,  1512,  1514,  1519,
    1524,  1530,  1533,  1535,  1537,  1539,  1541,  1543,  1545,  1547,
    1549,  1551,  1553,  1555,  1557,  1559,  1561,  1563,  1565,  1567,
    1569,  1571,  1573,  1575,  1577,  1579,  1581,  1583,  1585,  1587,
    1589,  1591,  1593,  1595,  1597,  1599,  1601,  1603,  1605,  1607,
    1609,  1611,  1613,  1615,  1617,  1619,  1621,  1623,  1625,  1627,
    1629,  1631,  1633,  1635,  1637,  1639,  1641,  1643,  1645,  1647,
    1649,  1654,  1659,  1664,  1669,  1674,  1679,  1684,  1689,  1694,
    1699,  1704,  1709,  1714,  1719,  1724,  1729,  1734,  1739,  1744,
    1749,  1754,  1759,  1764,  1769,  1774,  1779,  1784,  1789,  1794,
    1799,  1804,  1809,  1814,  1819,  1824,  1829,  1834,  1839,  1844,
    1849,  1854,  1859,  1864,  1869,  1874,  1879,  1884,  1889,  1894,
    1899,  1904,  1905,  1911,  1915,  1917,  1919,  1921,  1923,  1925,
    1927,  1929,  1931,  1933,  1935,  1937,  1939,  1941,  1943,  1945,
    1947,  1949,  1951,  1953,  1955,  1957,  1958,  1964,  1968,  1970,
    1972,  1974,  1976,  1978,  1980,  1982,  1984,  1986,  1988,  1990,
    1992,  1994,  1996,  1998,  2000,  2002,  2004,  2006,  2008,  2010,
    2015,  2020,  2025,  2030,  2035,  2036,  2043,  2046,  2048,  2050,
    2052,  2054,  2056,  2058,  2060,  2062,  2067,  2072,  2073,  2079,
    2083,  2085,  2087,  2089,  2094,  2099,  2100,  2106,  2110,  2112,
    2114,  2116,  2122,  2125,  2127,  2129,  2131,  2133,  2135,  2137,
    2139,  2141,  2143,  2145,  2147,  2149,  2151,  2153,  2155,  2157,
    2159,  2161,  2163,  2165,  2167,  2172,  2177,  2182,  2187,  2192,
    2197,  2202,  2207,  2212,  2217,  2222,  2227,  2232,  2237,  2242,
    2247,  2252,  2257,  2262,  2268,  2271,  2273,  2275,  2277,  2279,
    2281,  2283,  2285,  2287,  2289,  2294,  2299,  2304,  2309,  2314,
    2319
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     271,     0,    -1,    -1,   271,   272,    -1,   296,    -1,   302,
      -1,   317,    -1,   585,    -1,   355,    -1,   375,    -1,   389,
      -1,   282,    -1,   607,    -1,   416,    -1,   423,    -1,   433,
      -1,   442,    -1,   473,    -1,   483,    -1,   489,    -1,   504,
      -1,   569,    -1,   494,    -1,   277,    -1,     1,   265,    -1,
       1,   266,    -1,    -1,   274,    -1,   135,   273,    -1,   135,
     175,   273,    -1,   135,   176,   273,    -1,   135,   177,   273,
      -1,   135,   178,   273,    -1,   135,   179,   273,    -1,    -1,
     276,    -1,   135,   275,    -1,   135,    14,   275,    -1,   135,
      15,   275,    -1,   135,    16,   275,    -1,   123,   267,   278,
     266,   265,    -1,   278,   279,    -1,   279,    -1,   280,    -1,
     281,    -1,     1,   265,    -1,   122,   268,   157,   265,    -1,
     152,   268,   157,   265,    -1,   183,   267,   283,   266,   265,
      -1,   283,   284,    -1,   284,    -1,   287,    -1,   292,    -1,
     295,    -1,   289,    -1,   290,    -1,   291,    -1,   294,    -1,
     286,    -1,   293,    -1,   288,    -1,   285,    -1,     1,   265,
      -1,   172,   268,   157,   265,    -1,   170,   268,   157,   265,
      -1,   124,   268,   157,   265,    -1,   185,   268,   157,   265,
      -1,    37,   268,   157,   265,    -1,   127,   268,   157,   265,
      -1,   126,   268,   157,   265,    -1,   260,   268,   157,   265,
      -1,   261,   268,   157,   265,    -1,   229,   268,   135,   265,
      -1,    87,   268,   199,   265,    -1,     5,   267,   297,   266,
     265,    -1,   297,   298,    -1,   298,    -1,   299,    -1,   301,
      -1,   300,    -1,     1,   265,    -1,   124,   268,   157,   265,
      -1,    48,   268,   157,   265,    -1,    37,   268,   157,   265,
      -1,   107,   267,   303,   266,   265,    -1,   303,   304,    -1,
     304,    -1,   305,    -1,   306,    -1,   315,    -1,   316,    -1,
     307,    -1,   309,    -1,   311,    -1,   312,    -1,   314,    -1,
     310,    -1,   313,    -1,   308,    -1,     1,   265,    -1,   221,
     268,   157,   265,    -1,   142,   268,   157,   265,    -1,    64,
     268,   157,   265,    -1,    57,   268,   157,   265,    -1,    62,
     268,   157,   265,    -1,    63,   268,   157,   265,    -1,    60,
     268,   157,   265,    -1,    59,   268,   157,   265,    -1,    61,
     268,   157,   265,    -1,    58,   268,   157,   265,    -1,   108,
     268,   222,   265,    -1,   108,   268,   224,   265,    -1,   108,
     268,   228,   265,    -1,   108,   268,   226,   265,    -1,   108,
     268,   227,   265,    -1,   108,   268,   225,   265,    -1,   108,
     268,   223,   265,    -1,   258,   268,   199,   265,    -1,    -1,
     140,   318,   319,   267,   320,   266,   265,    -1,    -1,   323,
      -1,   320,   321,    -1,   321,    -1,   322,    -1,   324,    -1,
     326,    -1,   345,    -1,   346,    -1,   330,    -1,   329,    -1,
     334,    -1,   335,    -1,   337,    -1,   338,    -1,   339,    -1,
     340,    -1,   341,    -1,   336,    -1,   342,    -1,   343,    -1,
     344,    -1,   347,    -1,   327,    -1,   328,    -1,   325,    -1,
     348,    -1,     1,   265,    -1,   124,   268,   157,   265,    -1,
     157,    -1,   252,   268,   157,   265,    -1,    89,   268,   157,
     265,    -1,   151,   268,   157,   265,    -1,    50,   268,   199,
     265,    -1,   171,   268,   157,   265,    -1,    26,   268,   157,
     265,    -1,    -1,   238,   331,   268,   332,   265,    -1,   332,
     269,   333,    -1,   333,    -1,   206,    -1,   209,    -1,   210,
      -1,   212,    -1,   213,    -1,   216,    -1,   235,    -1,   230,
      -1,   232,    -1,   239,    -1,   236,    -1,   215,    -1,   231,
      -1,   234,    -1,   217,    -1,   242,    -1,   207,    -1,   208,
      -1,   220,    -1,   243,    -1,    74,   268,   199,   265,    -1,
     165,   268,   199,   265,    -1,   166,   268,   199,   265,    -1,
      96,   268,   199,   265,    -1,   262,   268,   199,   265,    -1,
     251,   268,   199,   265,    -1,    67,   268,   199,   265,    -1,
     129,   268,   199,   265,    -1,    38,   268,   199,   265,    -1,
     163,   268,   199,   265,    -1,     5,   268,   199,   265,    -1,
      80,   268,   199,   265,    -1,    82,   268,   199,   265,    -1,
     231,   268,   199,   265,    -1,    -1,    55,   349,   268,   350,
     265,    -1,   350,   269,   351,    -1,   351,    -1,    -1,   134,
     352,   354,    -1,    -1,   353,   354,    -1,    74,    -1,   165,
      -1,    96,    -1,   251,    -1,   262,    -1,    67,    -1,    38,
      -1,   163,    -1,     5,    -1,    80,    -1,   129,    -1,   231,
      -1,   145,    -1,    82,    -1,   166,    -1,    50,    -1,    -1,
      26,   356,   357,   267,   358,   266,   265,    -1,    -1,   361,
      -1,   358,   359,    -1,   359,    -1,   360,    -1,   371,    -1,
     372,    -1,   362,    -1,   363,    -1,   373,    -1,   364,    -1,
     365,    -1,   366,    -1,   367,    -1,   368,    -1,   369,    -1,
     370,    -1,   374,    -1,     1,   265,    -1,   124,   268,   157,
     265,    -1,   157,    -1,   154,   268,   274,   265,    -1,   155,
     268,   274,   265,    -1,   138,   268,   135,   265,    -1,    30,
     268,   274,   265,    -1,   117,   268,   135,   265,    -1,   112,
     268,   135,   265,    -1,   114,   268,   135,   265,    -1,   113,
     268,   135,   265,    -1,   180,   268,   276,   265,    -1,    23,
     268,   135,   265,    -1,    24,   268,   135,   265,    -1,   137,
     268,   135,   265,    -1,   167,   268,   157,   265,    -1,    -1,
     105,   376,   267,   381,   266,   265,    -1,    -1,    55,   378,
     268,   379,   265,    -1,   379,   269,   380,    -1,   380,    -1,
     237,    -1,    79,    -1,   233,    -1,   381,   382,    -1,   382,
      -1,   383,    -1,   377,    -1,   387,    -1,   388,    -1,     1,
     265,    -1,    -1,   156,   268,   385,   384,   265,    -1,   385,
     269,   386,    -1,   386,    -1,   135,    -1,   135,   204,   135,
      -1,    93,   268,   157,   265,    -1,    86,   268,   157,   265,
      -1,    -1,    76,   390,   267,   391,   266,   265,    -1,   391,
     392,    -1,   392,    -1,   393,    -1,   394,    -1,   397,    -1,
     399,    -1,   406,    -1,   407,    -1,   408,    -1,   410,    -1,
     411,    -1,   412,    -1,   396,    -1,   413,    -1,   414,    -1,
     409,    -1,   415,    -1,   398,    -1,   395,    -1,     1,   265,
      -1,   252,   268,   157,   265,    -1,   151,   268,   157,   265,
      -1,    89,   268,   157,   265,    -1,   193,   268,   199,   265,
      -1,    26,   268,   157,   265,    -1,    50,   268,   199,   265,
      -1,    -1,    55,   400,   268,   401,   265,    -1,   401,   269,
     402,    -1,   402,    -1,    -1,   134,   403,   405,    -1,    -1,
     404,   405,    -1,   193,    -1,    51,    -1,    97,    -1,    77,
      -1,    20,    -1,    21,    -1,   133,    -1,    69,    -1,   174,
      -1,   125,    -1,    97,   268,   199,   265,    -1,    77,   268,
     199,   265,    -1,    51,   268,   199,   265,    -1,    20,   268,
     199,   265,    -1,   133,   268,   199,   265,    -1,    69,   268,
     199,   265,    -1,   192,   268,   157,   265,    -1,   161,   268,
     157,   265,    -1,   160,   268,   135,   265,    -1,   125,   268,
     199,   265,    -1,    -1,   173,   417,   267,   418,   266,   265,
      -1,   418,   419,    -1,   419,    -1,   420,    -1,   421,    -1,
     422,    -1,     1,   265,    -1,   159,   268,   157,   265,    -1,
      22,   268,   157,   265,    -1,   128,   268,   157,   265,    -1,
      -1,   187,   424,   267,   425,   266,   265,    -1,   425,   426,
      -1,   426,    -1,   427,    -1,   428,    -1,   429,    -1,     1,
     265,    -1,   124,   268,   157,   265,    -1,   252,   268,   157,
     265,    -1,    -1,   189,   430,   268,   431,   265,    -1,   431,
     269,   432,    -1,   432,    -1,    96,    -1,   248,    -1,   251,
      -1,   262,    -1,   249,    -1,   241,    -1,   173,    -1,   250,
      -1,   240,    -1,   220,    -1,   205,    -1,    -1,   188,   434,
     267,   435,   266,   265,    -1,   435,   436,    -1,   436,    -1,
     437,    -1,   438,    -1,     1,   265,    -1,   124,   268,   157,
     265,    -1,    -1,   189,   439,   268,   440,   265,    -1,   440,
     269,   441,    -1,   441,    -1,    96,    -1,   248,    -1,   251,
      -1,   262,    -1,   249,    -1,   241,    -1,   173,    -1,   250,
      -1,   240,    -1,   220,    -1,   205,    -1,    -1,    29,   443,
     444,   267,   445,   266,   265,    -1,    -1,   448,    -1,   445,
     446,    -1,   446,    -1,   447,    -1,   449,    -1,   450,    -1,
     451,    -1,   452,    -1,   454,    -1,   453,    -1,   455,    -1,
     456,    -1,   469,    -1,   470,    -1,   471,    -1,   467,    -1,
     464,    -1,   466,    -1,   465,    -1,   463,    -1,   472,    -1,
     468,    -1,     1,   265,    -1,   124,   268,   157,   265,    -1,
     157,    -1,    86,   268,   157,   265,    -1,   260,   268,   157,
     265,    -1,   181,   268,   157,   265,    -1,     3,   268,   157,
     265,    -1,   156,   268,   135,   265,    -1,     6,   268,   218,
     265,    -1,     6,   268,   219,   265,    -1,    54,   268,   157,
     265,    -1,    -1,    55,   457,   268,   458,   265,    -1,   458,
     269,   459,    -1,   459,    -1,    -1,   134,   460,   462,    -1,
      -1,   461,   462,    -1,   102,    -1,    27,    -1,    31,    -1,
      10,    -1,    12,    -1,   246,    -1,   171,   268,   157,   265,
      -1,    50,   268,   199,   265,    -1,    31,   268,   199,   265,
      -1,    27,   268,   199,   265,    -1,    10,   268,   199,   265,
      -1,   246,   268,   199,   265,    -1,    88,   268,   157,   265,
      -1,   103,   268,   157,   265,    -1,    26,   268,   157,   265,
      -1,    25,   268,   157,   265,    -1,    -1,    94,   474,   267,
     479,   266,   265,    -1,    -1,   189,   476,   268,   477,   265,
      -1,   477,   269,   478,    -1,   478,    -1,   162,    -1,   479,
     480,    -1,   480,    -1,   481,    -1,   482,    -1,   475,    -1,
       1,    -1,   252,   268,   157,   265,    -1,   159,   268,   157,
     265,    -1,    -1,    36,   484,   267,   485,   266,   265,    -1,
     485,   486,    -1,   486,    -1,   487,    -1,   488,    -1,     1,
      -1,    93,   268,   157,   265,    -1,   159,   268,   157,   265,
      -1,    52,   267,   490,   266,   265,    -1,   490,   491,    -1,
     491,    -1,   492,    -1,   493,    -1,     1,    -1,    93,   268,
     157,   265,    -1,    89,   268,   157,   265,    -1,    -1,    65,
     495,   267,   500,   266,   265,    -1,    -1,   189,   497,   268,
     498,   265,    -1,   498,   269,   499,    -1,   499,    -1,   162,
      -1,   500,   501,    -1,   501,    -1,   502,    -1,   503,    -1,
     496,    -1,     1,    -1,   124,   268,   157,   265,    -1,   159,
     268,   157,   265,    -1,    66,   267,   505,   266,   265,    -1,
     505,   506,    -1,   506,    -1,   514,    -1,   515,    -1,   517,
      -1,   518,    -1,   519,    -1,   520,    -1,   521,    -1,   522,
      -1,   523,    -1,   524,    -1,   513,    -1,   526,    -1,   527,
      -1,   528,    -1,   529,    -1,   546,    -1,   532,    -1,   534,
      -1,   536,    -1,   535,    -1,   539,    -1,   533,    -1,   540,
      -1,   541,    -1,   542,    -1,   543,    -1,   545,    -1,   544,
      -1,   560,    -1,   547,    -1,   551,    -1,   552,    -1,   556,
      -1,   537,    -1,   538,    -1,   566,    -1,   564,    -1,   565,
      -1,   548,    -1,   516,    -1,   549,    -1,   550,    -1,   567,
      -1,   555,    -1,   525,    -1,   568,    -1,   553,    -1,   554,
      -1,   509,    -1,   512,    -1,   507,    -1,   508,    -1,   510,
      -1,   511,    -1,   530,    -1,   531,    -1,     1,    -1,    72,
     268,   135,   265,    -1,    73,   268,   135,   265,    -1,    12,
     268,   199,   265,    -1,   259,   268,   199,   265,    -1,   164,
     268,   274,   265,    -1,   186,   268,   199,   265,    -1,    95,
     268,   135,   265,    -1,    85,   268,   199,   265,    -1,    91,
     268,   199,   265,    -1,    43,   268,   199,   265,    -1,    53,
     268,   199,   265,    -1,     8,   268,   199,   265,    -1,   116,
     268,   274,   265,    -1,   115,   268,   135,   265,    -1,   109,
     268,   135,   265,    -1,     9,   268,   274,   265,    -1,   203,
     268,   274,   265,    -1,   202,   268,   274,   265,    -1,    78,
     268,   135,   265,    -1,    99,   268,   199,   265,    -1,    98,
     268,   157,   265,    -1,    92,   268,   199,   265,    -1,   264,
     268,   199,   265,    -1,   194,   268,   199,   265,    -1,    75,
     268,   274,   265,    -1,   197,   268,   199,   265,    -1,   198,
     268,   199,   265,    -1,   196,   268,   199,   265,    -1,   196,
     268,   200,   265,    -1,   195,   268,   199,   265,    -1,   195,
     268,   200,   265,    -1,   149,   268,   274,   265,    -1,    19,
     268,   274,   265,    -1,   141,   268,   199,   265,    -1,   150,
     268,   274,   265,    -1,   190,   268,   199,   265,    -1,   132,
     268,   199,   265,    -1,   247,   268,   199,   265,    -1,   144,
     268,   199,   265,    -1,   119,   268,   157,   265,    -1,    90,
     268,   274,   265,    -1,    45,   268,   135,   265,    -1,   118,
     268,   135,   265,    -1,   184,   268,   157,   265,    -1,    32,
     268,   157,   265,    -1,    28,   268,   135,   265,    -1,   253,
     268,   199,   265,    -1,    47,   268,   157,   265,    -1,   153,
     268,   199,   265,    -1,    39,   268,   199,   265,    -1,   245,
     268,   274,   265,    -1,    -1,   146,   557,   268,   558,   265,
      -1,   558,   269,   559,    -1,   559,    -1,   206,    -1,   209,
      -1,   210,    -1,   212,    -1,   213,    -1,   216,    -1,   235,
      -1,   230,    -1,   232,    -1,   239,    -1,   236,    -1,   215,
      -1,   231,    -1,   234,    -1,   217,    -1,   242,    -1,   207,
      -1,   208,    -1,   220,    -1,   243,    -1,    -1,   143,   561,
     268,   562,   265,    -1,   562,   269,   563,    -1,   563,    -1,
     206,    -1,   209,    -1,   210,    -1,   212,    -1,   213,    -1,
     216,    -1,   235,    -1,   230,    -1,   232,    -1,   239,    -1,
     236,    -1,   215,    -1,   231,    -1,   234,    -1,   217,    -1,
     242,    -1,   207,    -1,   208,    -1,   220,    -1,   243,    -1,
     120,   268,   135,   265,    -1,   121,   268,   135,   265,    -1,
      33,   268,   135,   265,    -1,   211,   268,   276,   265,    -1,
      44,   268,   199,   265,    -1,    -1,    68,   570,   267,   571,
     266,   265,    -1,   571,   572,    -1,   572,    -1,   573,    -1,
     574,    -1,   575,    -1,   579,    -1,   580,    -1,   581,    -1,
       1,    -1,    49,   268,   199,   265,    -1,    46,   268,   274,
     265,    -1,    -1,   107,   576,   268,   577,   265,    -1,   577,
     269,   578,    -1,   578,    -1,   201,    -1,    11,    -1,   252,
     268,   157,   265,    -1,   124,   268,   157,   265,    -1,    -1,
       4,   582,   268,   583,   265,    -1,   583,   269,   584,    -1,
     584,    -1,   201,    -1,    11,    -1,    22,   267,   586,   266,
     265,    -1,   586,   587,    -1,   587,    -1,   590,    -1,   591,
      -1,   592,    -1,   593,    -1,   594,    -1,   599,    -1,   595,
      -1,   596,    -1,   597,    -1,   598,    -1,   600,    -1,   601,
      -1,   602,    -1,   589,    -1,   603,    -1,   604,    -1,   605,
      -1,   606,    -1,   588,    -1,     1,    -1,    40,   268,   199,
     265,    -1,   168,   268,   199,   265,    -1,    42,   268,   199,
     265,    -1,   254,   268,   199,   265,    -1,   255,   268,   199,
     265,    -1,   256,   268,   199,   265,    -1,   257,   268,   199,
     265,    -1,   100,   268,   274,   265,    -1,   101,   268,   274,
     265,    -1,   111,   268,   135,   265,    -1,   158,   268,   199,
     265,    -1,   110,   268,   135,   265,    -1,    35,   268,   135,
     265,    -1,    34,   268,   135,   265,    -1,   130,   268,   199,
     265,    -1,   131,   268,   199,   265,    -1,    13,   268,   199,
     265,    -1,   147,   268,   135,   265,    -1,   148,   268,   274,
     265,    -1,   182,   267,   608,   266,   265,    -1,   608,   609,
      -1,   609,    -1,   610,    -1,   611,    -1,   613,    -1,   615,
      -1,   614,    -1,   612,    -1,   616,    -1,     1,    -1,    56,
     268,   199,   265,    -1,    84,   268,   199,   265,    -1,    81,
     268,   157,   265,    -1,   104,   268,   274,   265,    -1,    79,
     268,   199,   265,    -1,    41,   268,   199,   265,    -1,    83,
     268,   199,   265,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   404,   404,   405,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   433,   433,   434,   438,
     442,   446,   450,   454,   460,   460,   461,   462,   463,   464,
     471,   474,   474,   475,   475,   475,   477,   490,   501,   504,
     505,   506,   506,   507,   507,   508,   508,   509,   510,   510,
     511,   511,   512,   514,   548,   608,   622,   637,   646,   660,
     669,   697,   727,   750,   800,   802,   802,   803,   803,   804,
     804,   806,   815,   824,   837,   839,   840,   842,   842,   843,
     844,   844,   845,   845,   846,   846,   847,   847,   848,   849,
     851,   855,   859,   866,   873,   880,   887,   894,   901,   908,
     915,   919,   923,   927,   931,   935,   939,   945,   955,   954,
    1054,  1054,  1055,  1055,  1056,  1056,  1056,  1056,  1057,  1057,
    1058,  1058,  1058,  1059,  1059,  1059,  1060,  1060,  1060,  1061,
    1061,  1061,  1061,  1062,  1062,  1062,  1063,  1063,  1065,  1077,
    1089,  1123,  1142,  1154,  1165,  1207,  1217,  1216,  1222,  1222,
    1223,  1227,  1231,  1235,  1239,  1243,  1247,  1251,  1255,  1259,
    1263,  1267,  1271,  1275,  1279,  1283,  1287,  1291,  1295,  1299,
    1305,  1316,  1327,  1338,  1349,  1360,  1371,  1382,  1393,  1404,
    1415,  1426,  1437,  1448,  1460,  1459,  1463,  1463,  1464,  1464,
    1465,  1465,  1467,  1474,  1481,  1488,  1495,  1502,  1509,  1516,
    1523,  1530,  1537,  1544,  1551,  1558,  1565,  1572,  1586,  1585,
    1639,  1639,  1641,  1641,  1642,  1643,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1657,
    1666,  1675,  1681,  1687,  1693,  1699,  1705,  1711,  1717,  1723,
    1729,  1735,  1741,  1747,  1760,  1759,  1776,  1775,  1780,  1780,
    1781,  1785,  1789,  1797,  1797,  1798,  1798,  1798,  1798,  1798,
    1800,  1800,  1802,  1802,  1804,  1818,  1838,  1847,  1860,  1859,
    1934,  1934,  1935,  1935,  1935,  1935,  1936,  1936,  1937,  1937,
    1937,  1938,  1938,  1939,  1939,  1939,  1940,  1940,  1940,  1940,
    1942,  1979,  1992,  2012,  2023,  2032,  2044,  2043,  2047,  2047,
    2048,  2048,  2049,  2049,  2051,  2059,  2066,  2073,  2080,  2087,
    2094,  2101,  2108,  2115,  2124,  2135,  2146,  2157,  2168,  2179,
    2191,  2210,  2220,  2229,  2245,  2244,  2260,  2260,  2261,  2261,
    2261,  2261,  2263,  2272,  2287,  2301,  2300,  2316,  2316,  2317,
    2317,  2317,  2317,  2319,  2328,  2351,  2350,  2356,  2356,  2357,
    2361,  2365,  2369,  2373,  2377,  2381,  2385,  2389,  2393,  2397,
    2407,  2406,  2423,  2423,  2424,  2424,  2424,  2426,  2433,  2432,
    2438,  2438,  2439,  2443,  2447,  2451,  2455,  2459,  2463,  2467,
    2471,  2475,  2479,  2489,  2488,  2634,  2634,  2635,  2635,  2636,
    2636,  2636,  2637,  2637,  2638,  2638,  2639,  2639,  2639,  2640,
    2640,  2640,  2641,  2641,  2641,  2642,  2642,  2643,  2643,  2645,
    2657,  2669,  2678,  2704,  2722,  2740,  2746,  2750,  2758,  2768,
    2767,  2771,  2771,  2772,  2772,  2773,  2773,  2775,  2782,  2793,
    2800,  2807,  2814,  2824,  2865,  2876,  2887,  2902,  2913,  2924,
    2937,  2950,  2959,  2995,  2994,  3059,  3058,  3062,  3062,  3063,
    3069,  3069,  3070,  3070,  3070,  3070,  3072,  3091,  3101,  3100,
    3122,  3122,  3123,  3123,  3123,  3125,  3134,  3146,  3148,  3148,
    3149,  3149,  3149,  3151,  3169,  3202,  3201,  3244,  3243,  3247,
    3247,  3248,  3254,  3254,  3255,  3255,  3255,  3255,  3257,  3263,
    3272,  3275,  3275,  3276,  3276,  3277,  3277,  3278,  3278,  3279,
    3279,  3280,  3280,  3281,  3281,  3282,  3282,  3283,  3283,  3284,
    3284,  3285,  3285,  3286,  3286,  3287,  3287,  3288,  3288,  3289,
    3289,  3290,  3290,  3291,  3291,  3292,  3292,  3293,  3293,  3294,
    3294,  3295,  3295,  3296,  3297,  3297,  3298,  3298,  3299,  3299,
    3300,  3300,  3301,  3301,  3302,  3302,  3303,  3303,  3304,  3305,
    3309,  3314,  3319,  3324,  3329,  3334,  3339,  3344,  3349,  3354,
    3359,  3364,  3369,  3374,  3379,  3384,  3389,  3394,  3400,  3411,
    3416,  3425,  3430,  3435,  3440,  3445,  3450,  3455,  3458,  3463,
    3466,  3471,  3476,  3481,  3486,  3491,  3496,  3501,  3506,  3511,
    3522,  3527,  3532,  3537,  3546,  3578,  3596,  3601,  3610,  3615,
    3620,  3626,  3625,  3630,  3630,  3631,  3634,  3637,  3640,  3643,
    3646,  3649,  3652,  3655,  3658,  3661,  3664,  3667,  3670,  3673,
    3676,  3679,  3682,  3685,  3688,  3694,  3693,  3698,  3698,  3699,
    3702,  3705,  3708,  3711,  3714,  3717,  3720,  3723,  3726,  3729,
    3732,  3735,  3738,  3741,  3744,  3747,  3750,  3753,  3756,  3761,
    3766,  3771,  3776,  3781,  3790,  3789,  3813,  3813,  3814,  3815,
    3816,  3817,  3818,  3819,  3820,  3822,  3828,  3835,  3834,  3839,
    3839,  3840,  3844,  3850,  3884,  3894,  3893,  3943,  3943,  3944,
    3948,  3957,  3960,  3960,  3961,  3961,  3962,  3962,  3962,  3963,
    3963,  3964,  3964,  3965,  3965,  3966,  3967,  3967,  3968,  3968,
    3969,  3969,  3970,  3970,  3972,  3977,  3982,  3987,  3992,  3997,
    4002,  4007,  4012,  4017,  4022,  4027,  4032,  4037,  4042,  4047,
    4052,  4057,  4062,  4070,  4073,  4073,  4074,  4074,  4075,  4076,
    4077,  4077,  4078,  4079,  4081,  4087,  4093,  4102,  4116,  4122,
    4128
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACTION", "ADMIN",
  "AFTYPE", "T_ALLOW", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "T_BLOCK", "BURST_AWAY", "BURST_TOPICWHO", "BYTES", "KBYTES",
  "MBYTES", "GBYTES", "TBYTES", "CALLER_ID_WAIT", "CAN_FLOOD", "CAN_IDLE",
  "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6", "CIPHER_PREFERENCE",
  "CLASS", "COMPRESSED", "COMPRESSION_LEVEL", "CONNECT", "CONNECTFREQ",
  "CRYPTLINK", "DEFAULT_CIPHER_PREFERENCE", "DEFAULT_FLOODCOUNT",
  "DEFAULT_SPLIT_SERVER_COUNT", "DEFAULT_SPLIT_USER_COUNT", "DENY",
  "DESCRIPTION", "DIE", "DISABLE_AUTH", "DISABLE_FAKE_CHANNELS",
  "DISABLE_HIDDEN", "DISABLE_LOCAL_CHANNELS", "DISABLE_REMOTE_COMMANDS",
  "DOT_IN_IP6_ADDR", "DOTS_IN_IDENT", "DURATION", "EGDPOOL_PATH", "EMAIL",
  "ENABLE", "ENCRYPTED", "EXCEED_LIMIT", "EXEMPT", "FAILED_OPER_NOTICE",
  "FAKENAME", "IRCD_FLAGS", "FLATTEN_LINKS", "FFAILED_OPERLOG", "FKILLLOG",
  "FKLINELOG", "FGLINELOG", "FIOERRLOG", "FOPERLOG", "FOPERSPYLOG",
  "FUSERLOG", "GECOS", "GENERAL", "GLINE", "GLINES", "GLINE_EXEMPT",
  "GLINE_LOG", "GLINE_TIME", "GLINE_MIN_CIDR", "GLINE_MIN_CIDR6",
  "GLOBAL_KILL", "GODMODE_TIMEOUT", "IRCD_AUTH", "NEED_IDENT",
  "HAVENT_READ_CONF", "HIDDEN", "HIDDEN_ADMIN", "HIDDEN_NAME",
  "HIDDEN_OPER", "HIDE_SERVER_IPS", "HIDE_SERVERS", "HIDE_SPOOF_IPS",
  "HOST", "HUB", "HUB_MASK", "CLIENTCERT_HASH", "IDLETIME",
  "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT", "IP", "KILL",
  "KILL_CHASE_TIME_LIMIT", "KLINE", "KLINE_EXEMPT", "KLINE_REASON",
  "KLINE_WITH_REASON", "KNOCK_DELAY", "KNOCK_DELAY_CHANNEL", "LAZYLINK",
  "LEAF_MASK", "LINKS_DELAY", "LISTEN", "T_LOG", "LOGGING", "LOG_LEVEL",
  "MAX_ACCEPT", "MAX_BANS", "MAX_CHANS_PER_USER", "MAX_GLOBAL",
  "MAX_IDENT", "MAX_LOCAL", "MAX_NICK_CHANGES", "MAX_NICK_TIME",
  "MAX_NUMBER", "MAX_TARGETS", "MESSAGE_LOCALE", "MIN_NONWILDCARD",
  "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "NAME", "NEED_PASSWORD",
  "NETWORK_DESC", "NETWORK_NAME", "NICK", "NICK_CHANGES",
  "NO_CREATE_ON_SPLIT", "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE",
  "NOT", "NUMBER", "NUMBER_PER_IDENT", "NUMBER_PER_CIDR", "NUMBER_PER_IP",
  "NUMBER_PER_IP_GLOBAL", "OPERATOR", "OPERS_BYPASS_CALLERID", "OPER_LOG",
  "OPER_ONLY_UMODES", "OPER_PASS_RESV", "OPER_SPY_T", "OPER_UMODES",
  "JOIN_FLOOD_COUNT", "JOIN_FLOOD_TIME", "PACE_WAIT", "PACE_WAIT_SIMPLE",
  "PASSWORD", "PATH", "PING_COOKIE", "PING_TIME", "PING_WARNING", "PORT",
  "QSTRING", "QUIET_ON_BAN", "REASON", "REDIRPORT", "REDIRSERV", "REGEX_T",
  "REHASH", "TREJECT_HOLD_TIME", "REMOTE", "REMOTEBAN", "REJECT_MESSAGE",
  "RESTRICT_CHANNELS", "RESTRICTED", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SSL_CERTIFICATE_FILE", "RESV", "RESV_EXEMPT",
  "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS", "SENDQ", "SEND_PASSWORD",
  "SERVERHIDE", "SERVERINFO", "SERVLINK_PATH", "IRCD_SID",
  "TKLINE_EXPIRE_NOTICES", "T_SHARED", "T_CLUSTER", "TYPE", "SHORT_MOTD",
  "SILENT", "SPOOF", "SPOOF_NOTICE", "STATS_E_DISABLED",
  "STATS_I_OPER_ONLY", "STATS_K_OPER_ONLY", "STATS_O_OPER_ONLY",
  "STATS_P_OPER_ONLY", "TBOOL", "TMASKED", "T_REJECT", "TS_MAX_DELTA",
  "TS_WARN_DELTA", "TWODOTS", "T_ALL", "T_BOTS", "T_SOFTCALLERID",
  "T_CALLERID", "T_CCONN", "T_CCONN_FULL", "T_CLIENT_FLOOD", "T_DEAF",
  "T_DEBUG", "T_DRONE", "T_EXTERNAL", "T_FULL", "T_INVISIBLE", "T_IPV4",
  "T_IPV6", "T_LOCOPS", "T_LOGPATH", "T_L_CRIT", "T_L_DEBUG", "T_L_ERROR",
  "T_L_INFO", "T_L_NOTICE", "T_L_TRACE", "T_L_WARN", "T_MAX_CLIENTS",
  "T_NCHANGE", "T_OPERWALL", "T_REJ", "T_SERVER", "T_SERVNOTICE",
  "T_SKILL", "T_SPY", "T_SSL", "T_UMODES", "T_UNAUTH", "T_UNRESV",
  "T_UNXLINE", "T_WALLOP", "T_GOD", "T_NICKSERVREG", "THROTTLE_TIME",
  "TOPICBURST", "TRUE_NO_OPER_FLOOD", "TKLINE", "TXLINE", "TRESV",
  "UNKLINE", "USER", "USE_EGD", "USE_EXCEPT", "USE_INVEX", "USE_QUIET",
  "USE_KNOCK", "USE_LOGGING", "USE_WHOIS_ACTUALLY", "VHOST", "VHOST6",
  "XLINE", "WARN", "WARN_NO_NLINE", "';'", "'}'", "'{'", "'='", "','",
  "$accept", "conf", "conf_item", "timespec_", "timespec", "sizespec_",
  "sizespec", "modules_entry", "modules_items", "modules_item",
  "modules_module", "modules_path", "serverinfo_entry", "serverinfo_items",
  "serverinfo_item", "serverinfo_ssl_certificate_file",
  "serverinfo_rsa_private_key_file", "serverinfo_name", "serverinfo_sid",
  "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_hub", "admin_entry", "admin_items",
  "admin_item", "admin_name", "admin_email", "admin_description",
  "logging_entry", "logging_items", "logging_item", "logging_path",
  "logging_oper_log", "logging_fuserlog", "logging_ffailed_operlog",
  "logging_foperlog", "logging_foperspylog", "logging_fglinelog",
  "logging_fklinelog", "logging_ioerrlog", "logging_killlog",
  "logging_log_level", "logging_use_logging", "oper_entry", "$@1",
  "oper_name_b", "oper_items", "oper_item", "oper_name", "oper_name_t",
  "oper_user", "oper_client_certificate_hash", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file", "oper_class",
  "oper_umodes", "$@2", "oper_umodes_items", "oper_umodes_item",
  "oper_global_kill", "oper_remote", "oper_remoteban", "oper_kline",
  "oper_xline", "oper_unkline", "oper_gline", "oper_nick_changes",
  "oper_die", "oper_rehash", "oper_admin", "oper_hidden_admin",
  "oper_hidden_oper", "oper_operwall", "oper_flags", "$@3",
  "oper_flags_items", "oper_flags_item", "$@4", "$@5",
  "oper_flags_item_atom", "class_entry", "$@6", "class_name_b",
  "class_items", "class_item", "class_name", "class_name_t",
  "class_ping_time", "class_ping_warning", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_max_ident", "class_sendq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_reject_message", "listen_entry", "$@7",
  "listen_flags", "$@8", "listen_flags_items", "listen_flags_item",
  "listen_items", "listen_item", "listen_port", "$@9", "port_items",
  "port_item", "listen_address", "listen_host", "auth_entry", "$@10",
  "auth_items", "auth_item", "auth_user", "auth_passwd",
  "auth_client_certificate_hash", "auth_spoof_notice", "auth_class",
  "auth_encrypted", "auth_flags", "$@11", "auth_flags_items",
  "auth_flags_item", "$@12", "$@13", "auth_flags_item_atom",
  "auth_kline_exempt", "auth_need_ident", "auth_exceed_limit",
  "auth_can_flood", "auth_no_tilde", "auth_gline_exempt", "auth_spoof",
  "auth_redir_serv", "auth_redir_port", "auth_need_password", "resv_entry",
  "$@14", "resv_items", "resv_item", "resv_creason", "resv_channel",
  "resv_nick", "shared_entry", "$@15", "shared_items", "shared_item",
  "shared_name", "shared_user", "shared_type", "$@16", "shared_types",
  "shared_type_item", "cluster_entry", "$@17", "cluster_items",
  "cluster_item", "cluster_name", "cluster_type", "$@18", "cluster_types",
  "cluster_type_item", "connect_entry", "$@19", "connect_name_b",
  "connect_items", "connect_item", "connect_name", "connect_name_t",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_port", "connect_aftype",
  "connect_fakename", "connect_flags", "$@20", "connect_flags_items",
  "connect_flags_item", "$@21", "$@22", "connect_flags_item_atom",
  "connect_rsa_public_key_file", "connect_encrypted", "connect_cryptlink",
  "connect_compressed", "connect_auto", "connect_topicburst",
  "connect_hub_mask", "connect_leaf_mask", "connect_class",
  "connect_cipher_preference", "kill_entry", "$@23", "kill_type", "$@24",
  "kill_type_items", "kill_type_item", "kill_items", "kill_item",
  "kill_user", "kill_reason", "deny_entry", "$@25", "deny_items",
  "deny_item", "deny_ip", "deny_reason", "exempt_entry", "exempt_items",
  "exempt_item", "exempt_ip", "exempt_client_certificate_hash",
  "gecos_entry", "$@26", "gecos_flags", "$@27", "gecos_flags_items",
  "gecos_flags_item", "gecos_items", "gecos_item", "gecos_name",
  "gecos_reason", "general_entry", "general_items", "general_item",
  "general_gline_min_cidr", "general_gline_min_cidr6",
  "general_burst_away", "general_use_whois_actually",
  "general_reject_hold_time", "general_tkline_expire_notices",
  "general_kill_chase_time_limit", "general_hide_spoof_ips",
  "general_ignore_bogus_ts", "general_disable_remote_commands",
  "general_failed_oper_notice", "general_anti_nick_flood",
  "general_max_nick_time", "general_max_nick_changes",
  "general_max_accept", "general_anti_spam_exit_message_time",
  "general_ts_warn_delta", "general_ts_max_delta",
  "general_havent_read_conf", "general_kline_with_reason",
  "general_kline_reason", "general_invisible_on_connect",
  "general_warn_no_nline", "general_stats_e_disabled",
  "general_godmode_timeout", "general_stats_o_oper_only",
  "general_stats_P_oper_only", "general_stats_k_oper_only",
  "general_stats_i_oper_only", "general_pace_wait",
  "general_caller_id_wait", "general_opers_bypass_callerid",
  "general_pace_wait_simple", "general_short_motd",
  "general_no_oper_flood", "general_true_no_oper_flood",
  "general_oper_pass_resv", "general_message_locale", "general_idletime",
  "general_dots_in_ident", "general_max_targets", "general_servlink_path",
  "general_default_cipher_preference", "general_compression_level",
  "general_use_egd", "general_egdpool_path", "general_ping_cookie",
  "general_disable_auth", "general_throttle_time", "general_oper_umodes",
  "$@28", "umode_oitems", "umode_oitem", "general_oper_only_umodes",
  "$@29", "umode_items", "umode_item", "general_min_nonwildcard",
  "general_min_nonwildcard_simple", "general_default_floodcount",
  "general_client_flood", "general_dot_in_ip6_addr", "gline_entry", "$@30",
  "gline_items", "gline_item", "gline_enable", "gline_duration",
  "gline_logging", "$@31", "gline_logging_types",
  "gline_logging_type_item", "gline_user", "gline_server", "gline_action",
  "$@32", "gdeny_types", "gdeny_type_item", "channel_entry",
  "channel_items", "channel_item", "channel_disable_fake_channels",
  "channel_restrict_channels", "channel_disable_local_channels",
  "channel_use_except", "channel_use_invex", "channel_use_quiet",
  "channel_use_knock", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_quiet_on_ban", "channel_max_bans",
  "channel_default_split_user_count", "channel_default_split_server_count",
  "channel_no_create_on_split", "channel_no_join_on_split",
  "channel_burst_topicwho", "channel_jflood_count", "channel_jflood_time",
  "serverhide_entry", "serverhide_items", "serverhide_item",
  "serverhide_flatten_links", "serverhide_hide_servers",
  "serverhide_hidden_name", "serverhide_links_delay", "serverhide_hidden",
  "serverhide_disable_hidden", "serverhide_hide_server_ips", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,    59,   125,   123,    61,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   270,   271,   271,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   273,   273,   274,   274,
     274,   274,   274,   274,   275,   275,   276,   276,   276,   276,
     277,   278,   278,   279,   279,   279,   280,   281,   282,   283,
     283,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   297,   298,   298,   298,
     298,   299,   300,   301,   302,   303,   303,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,   304,   304,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   315,   315,   315,   315,   315,   315,   316,   318,   317,
     319,   319,   320,   320,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   331,   330,   332,   332,
     333,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   349,   348,   350,   350,   352,   351,
     353,   351,   354,   354,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   356,   355,
     357,   357,   358,   358,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   376,   375,   378,   377,   379,   379,
     380,   380,   380,   381,   381,   382,   382,   382,   382,   382,
     384,   383,   385,   385,   386,   386,   387,   388,   390,   389,
     391,   391,   392,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   392,   392,   392,   392,
     393,   394,   395,   396,   397,   398,   400,   399,   401,   401,
     403,   402,   404,   402,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   417,   416,   418,   418,   419,   419,
     419,   419,   420,   421,   422,   424,   423,   425,   425,   426,
     426,   426,   426,   427,   428,   430,   429,   431,   431,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     434,   433,   435,   435,   436,   436,   436,   437,   439,   438,
     440,   440,   441,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   443,   442,   444,   444,   445,   445,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   454,   455,   457,
     456,   458,   458,   460,   459,   461,   459,   462,   462,   462,
     462,   462,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   474,   473,   476,   475,   477,   477,   478,
     479,   479,   480,   480,   480,   480,   481,   482,   484,   483,
     485,   485,   486,   486,   486,   487,   488,   489,   490,   490,
     491,   491,   491,   492,   493,   495,   494,   497,   496,   498,
     498,   499,   500,   500,   501,   501,   501,   501,   502,   503,
     504,   505,   505,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   534,   535,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   557,   556,   558,   558,   559,   559,   559,   559,   559,
     559,   559,   559,   559,   559,   559,   559,   559,   559,   559,
     559,   559,   559,   559,   559,   561,   560,   562,   562,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   564,
     565,   566,   567,   568,   570,   569,   571,   571,   572,   572,
     572,   572,   572,   572,   572,   573,   574,   576,   575,   577,
     577,   578,   578,   579,   580,   582,   581,   583,   583,   584,
     584,   585,   586,   586,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   608,   609,   609,   609,   609,
     609,   609,   609,   609,   610,   611,   612,   613,   614,   615,
     616
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     1,     2,     3,
       3,     3,     3,     3,     0,     1,     2,     3,     3,     3,
       5,     2,     1,     1,     1,     2,     4,     4,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     5,     2,     1,     1,     1,     1,
       2,     4,     4,     4,     5,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     0,     7,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     4,     1,
       4,     4,     4,     4,     4,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     0,     5,     3,     1,     0,     3,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     7,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     0,     6,     0,     5,     3,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       0,     5,     3,     1,     1,     3,     4,     4,     0,     6,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     4,     0,     5,     3,     1,
       0,     3,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     2,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     2,     4,     4,     0,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     6,     2,     1,     1,     1,     2,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     7,     0,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     0,
       5,     3,     1,     0,     3,     0,     2,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     6,     0,     5,     3,     1,     1,
       2,     1,     1,     1,     1,     1,     4,     4,     0,     6,
       2,     1,     1,     1,     1,     4,     4,     5,     2,     1,
       1,     1,     1,     4,     4,     0,     6,     0,     5,     3,
       1,     1,     2,     1,     1,     1,     1,     1,     4,     4,
       5,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     0,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     4,     0,     5,     3,
       1,     1,     1,     4,     4,     0,     5,     3,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     5,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   218,   393,   468,     0,
     485,     0,   664,   278,   453,   254,     0,     0,   118,   334,
       0,     0,   345,   370,     3,    23,    11,     4,     5,     6,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      22,    20,    21,     7,    12,    24,    25,     0,     0,   220,
     395,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   120,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    76,    77,    79,    78,   713,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   693,   712,   707,
     694,   695,   696,   697,   698,   700,   701,   702,   703,   699,
     704,   705,   706,   708,   709,   710,   711,   240,     0,   221,
     420,     0,   396,     0,   482,     0,     0,     0,   479,   480,
     481,     0,   559,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   635,     0,   611,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     502,   553,   554,   551,   555,   556,   552,   513,   503,   504,
     542,   505,   506,   507,   508,   509,   510,   511,   512,   547,
     514,   515,   516,   517,   557,   558,   519,   524,   520,   522,
     521,   536,   537,   523,   525,   526,   527,   528,   530,   529,
     518,   532,   541,   543,   544,   533,   534,   549,   550,   546,
     535,   531,   539,   540,   538,   545,   548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    86,    87,    88,    91,    98,
      92,    96,    93,    94,    97,    95,    89,    90,     0,     0,
       0,     0,    42,    43,    44,   149,     0,   121,     0,   743,
       0,     0,     0,     0,     0,     0,     0,     0,   735,   736,
     737,   741,   738,   740,   739,   742,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      61,    58,    51,    60,    54,    55,    56,    52,    59,    57,
      53,     0,     0,    80,     0,     0,     0,     0,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   692,
       0,     0,   474,     0,     0,     0,   471,   472,   473,     0,
       0,     0,   478,   497,     0,     0,   487,   496,     0,   493,
     494,   495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   501,
     674,   685,     0,     0,   677,     0,     0,     0,   667,   668,
     669,   670,   671,   672,   673,     0,     0,     0,     0,     0,
     306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   281,   282,   283,   298,   292,   284,
     297,   285,   286,   287,   288,   295,   289,   290,   291,   293,
     294,   296,   465,     0,   455,     0,   464,     0,   461,   462,
     463,     0,   256,     0,     0,     0,   266,     0,   264,   265,
     267,   268,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    85,    45,     0,     0,
       0,    41,     0,     0,     0,     0,     0,     0,   337,   338,
     339,   340,     0,     0,     0,     0,     0,     0,     0,     0,
     734,    62,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,   355,     0,     0,
     348,   349,   350,   351,     0,     0,   378,     0,   373,   374,
     375,     0,     0,     0,    74,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   691,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,   224,   227,   228,   230,   231,   232,   233,
     234,   235,   236,   225,   226,   229,   237,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   398,   399,
     400,   401,   402,   403,   405,   404,   406,   407,   415,   412,
     414,   413,   411,   417,   408,   409,   410,   416,     0,     0,
       0,   470,     0,     0,   477,     0,     0,     0,     0,   492,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,     0,     0,   500,
       0,     0,     0,     0,     0,     0,     0,   666,   299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   280,     0,     0,
       0,     0,   460,   269,     0,     0,     0,     0,     0,   263,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,    40,     0,     0,     0,     0,     0,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   156,     0,     0,     0,     0,   123,   124,   125,
     145,   126,   143,   144,   130,   129,   131,   132,   138,   133,
     134,   135,   136,   137,   139,   140,   141,   127,   128,   142,
     146,   341,     0,     0,     0,     0,   336,     0,     0,     0,
       0,     0,     0,     0,   733,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,   352,     0,     0,
       0,     0,   347,   376,     0,     0,     0,   372,    83,    82,
      81,   730,   727,   726,   714,   716,    26,    26,    26,    26,
      26,    28,    27,   721,   722,   725,   723,   728,   729,   731,
     732,   724,   715,   717,   718,   719,   720,   238,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   222,   418,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   397,     0,     0,   469,   484,
     483,     0,     0,     0,   486,   571,   575,   562,   592,   605,
     604,   661,   609,   569,   663,   601,   607,   570,   560,   561,
     584,   578,   567,   600,   568,   581,   566,   580,   579,   574,
     573,   572,   602,   599,   659,   660,   596,   593,   639,   655,
     656,   640,   641,   642,   643,   650,   644,   653,   657,   646,
     651,   647,   652,   645,   649,   648,   654,   658,     0,   638,
     598,   615,   631,   632,   616,   617,   618,   619,   626,   620,
     629,   633,   622,   627,   623,   628,   621,   625,   624,   630,
     634,     0,   614,   591,   594,   608,   564,   603,   565,   595,
     583,   589,   590,   587,   588,   585,   586,   577,   576,    34,
      34,    34,    36,    35,   662,   610,   597,   606,   563,   582,
       0,     0,     0,     0,     0,     0,   665,     0,     0,     0,
       0,   312,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   279,     0,     0,     0,   454,     0,
       0,     0,   274,   270,   273,   255,   103,   109,   107,   106,
     108,   104,   105,   102,   110,   116,   111,   115,   113,   114,
     112,   101,   100,   117,    46,    47,   147,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   122,     0,     0,     0,   335,   749,   744,   748,   746,
     750,   745,   747,    67,    73,    65,    69,    68,    64,    63,
      66,    72,    70,    71,     0,     0,     0,   346,     0,     0,
     371,    29,    30,    31,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   435,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   394,   475,   476,   498,   499,   491,     0,   490,   636,
       0,   612,     0,    37,    38,    39,   690,   689,     0,   688,
     676,   675,   682,   681,     0,   680,   684,   683,   327,   304,
     305,   326,   310,     0,   309,     0,   329,   325,   302,   324,
     333,   328,   301,   332,   331,   330,   303,   300,   467,   459,
       0,   458,   466,   261,   262,   260,     0,   259,   277,   276,
       0,     0,     0,     0,     0,     0,     0,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   119,   343,   344,   342,
     353,   359,   365,   369,   368,   367,   364,   360,   363,   366,
     361,   362,     0,   358,   354,   377,   382,   388,   392,   391,
     390,   387,   383,   386,   389,   384,   385,     0,   381,   250,
     251,   244,   246,   248,   247,   245,   239,   252,   243,   241,
     242,   253,   249,   424,   426,   427,   447,   452,   451,   446,
     445,   444,   428,   433,     0,   432,     0,   421,   449,   450,
     419,   425,   443,   423,   448,   422,   488,     0,   637,   613,
     686,     0,   678,     0,     0,   307,   312,   318,   319,   315,
     321,   317,   316,   323,   320,   322,   314,   313,   456,     0,
     257,     0,   275,   272,   271,   190,   155,   188,   153,   198,
       0,   197,     0,   186,   180,   191,   192,   151,   183,   148,
     187,   152,   189,   181,   182,   154,   193,   160,   176,   177,
     161,   162,   163,   164,   171,   165,   174,   178,   167,   172,
     168,   173,   166,   170,   169,   175,   179,     0,   159,   185,
     150,   184,   356,     0,   379,     0,     0,   430,   435,   440,
     441,   438,   439,   437,   442,   436,   489,   687,   679,   311,
     308,   457,   258,     0,   195,   200,   210,   208,   217,   207,
     202,   211,   215,   204,   212,   214,   209,   203,   216,   213,
     205,   206,   201,   157,     0,   357,   380,   434,   431,   199,
     196,   158
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    24,   911,   912,  1072,  1073,    25,   281,   282,
     283,   284,    26,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    27,    71,    72,    73,
      74,    75,    28,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    29,    61,   286,
     836,   837,   838,   287,   839,   840,   841,   842,   843,   844,
     845,  1156,  1457,  1458,   846,   847,   848,   849,   850,   851,
     852,   853,   854,   855,   856,   857,   858,   859,   860,  1141,
    1420,  1421,  1483,  1422,  1502,    30,    49,   118,   621,   622,
     623,   119,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,    31,    58,   506,   784,  1286,
    1287,   507,   508,   509,  1292,  1113,  1114,   510,   511,    32,
      56,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     763,  1263,  1264,  1394,  1265,  1407,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    33,    62,   537,   538,
     539,   540,   541,    34,    65,   569,   570,   571,   572,   573,
     889,  1332,  1333,    35,    66,   577,   578,   579,   580,   895,
    1347,  1348,    36,    50,   121,   657,   658,   659,   122,   660,
     661,   662,   663,   664,   665,   666,   667,   954,  1374,  1375,
    1466,  1376,  1475,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,    37,    57,   496,   779,  1280,  1281,   497,
     498,   499,   500,    38,    51,   365,   366,   367,   368,    39,
     127,   128,   129,   130,    40,    53,   377,   687,  1237,  1238,
     378,   379,   380,   381,    41,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   417,  1051,  1052,
     241,   415,  1028,  1029,   242,   243,   244,   245,   246,    42,
      55,   447,   448,   449,   450,   451,   753,  1254,  1255,   452,
     453,   454,   750,  1248,  1249,    43,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,    44,   297,   298,
     299,   300,   301,   302,   303,   304,   305
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -932
static const yytype_int16 yypact[] =
{
    -932,   907,  -932,  -233,  -237,  -227,  -932,  -932,  -932,  -221,
    -932,  -204,  -932,  -932,  -932,  -932,  -199,  -189,  -932,  -932,
    -179,  -176,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,    13,   780,   -74,
     -57,  -170,    30,  -165,   537,  -153,  -119,  -107,   -79,   704,
       7,    36,   -59,   287,   415,   -50,   -48,   -58,   -34,   -27,
     -26,    12,  -932,  -932,  -932,  -932,  -932,   -25,   -18,   -17,
     -16,   -10,    -4,    -2,     4,    18,    21,    37,    44,    51,
      52,    53,    56,    62,    64,    66,   225,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   -31,  -932,
    -932,    20,  -932,    19,  -932,    69,    70,    16,  -932,  -932,
    -932,     9,  -932,    74,    76,    77,    80,    81,    91,    93,
      95,    96,    97,   101,   106,   109,   110,   111,   112,   113,
     117,   119,   120,   122,   124,   126,   127,   129,   130,   133,
     137,   138,   141,   142,   143,   144,  -932,   147,  -932,   150,
     152,   153,   155,   158,   159,   160,   165,   167,   168,   169,
     170,   171,   182,   188,   189,   191,   192,   193,   195,    26,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,   199,   806,     2,
      27,    38,   198,   201,   202,   205,   206,   207,   208,   209,
     210,   215,   219,   220,   385,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,    39,   222,
     224,    28,  -932,  -932,  -932,  -932,   227,  -932,    54,  -932,
     228,   233,   236,   237,   238,   239,   244,    11,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,   157,   245,   246,   248,
     250,   251,   252,   253,   256,   257,   258,   261,   338,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,     3,     8,  -932,   203,   262,   374,   230,  -932,    85,
     128,   398,   335,   336,   401,   401,   402,   408,   348,   349,
     416,   401,   351,   355,   356,   358,   359,   365,   301,  -932,
     839,   749,  -932,   300,   303,    35,  -932,  -932,  -932,   418,
     421,   314,  -932,  -932,   304,   320,  -932,  -932,    25,  -932,
    -932,  -932,   390,   401,   392,   401,   457,   439,   462,   403,
     404,   406,   466,   450,   409,   481,   483,   401,   484,   422,
     401,   424,   425,   485,   468,   427,   495,   496,   401,   498,
     477,   502,   503,   440,   441,   373,   443,   377,   401,   401,
     449,   401,   490,   451,   455,   460,   -69,   -37,   461,   463,
     401,   401,   526,   401,   467,   469,   471,   472,   400,  -932,
    -932,  -932,   405,   414,  -932,   423,   428,    47,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,   407,   429,   430,   434,   435,
    -932,   436,   445,   446,   447,   452,   454,   456,   458,   470,
     473,   475,   478,   307,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,   479,  -932,   486,  -932,    43,  -932,  -932,
    -932,   412,  -932,   488,   489,   492,  -932,    17,  -932,  -932,
    -932,  -932,  -932,   517,   532,   550,   551,   552,   554,   559,
     561,   764,   562,   568,   529,   465,  -932,  -932,   580,   588,
     504,  -932,   662,   505,   509,   510,   511,    15,  -932,  -932,
    -932,  -932,   572,   573,   574,   592,   584,   586,   401,   522,
    -932,  -932,   596,   589,   632,   635,   637,   638,   640,   641,
     665,   645,   648,   541,  -932,   543,   542,  -932,   548,    10,
    -932,  -932,  -932,  -932,   544,   549,  -932,    41,  -932,  -932,
    -932,   546,   553,   556,  -932,   558,   564,   565,   566,   569,
     175,   571,   576,   577,   578,   579,   582,   583,   585,   590,
     593,   594,   595,   599,   600,  -932,   601,   570,   581,   602,
     603,   604,   606,   608,   609,   610,   611,   614,   616,   617,
     618,   317,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,   622,   620,   621,
     624,   626,   628,   629,   630,   631,   633,  -932,   634,   636,
     647,   649,   650,   651,   653,   654,   655,   243,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   667,   682,
     644,  -932,   661,   669,  -932,   688,   694,   664,   670,  -932,
     672,   675,   676,   677,   679,   680,   681,   684,   685,   693,
     695,   696,   699,   700,   703,   705,   706,   709,   713,   714,
     715,   716,   717,   719,   731,   732,   735,   737,   739,   740,
     742,   743,   745,   890,   748,   928,   750,   751,   752,   753,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   767,
     768,   773,    92,   774,   775,   776,   777,   778,   779,  -932,
     701,   401,   668,   781,   697,   711,   783,  -932,  -932,   707,
     790,   830,   846,   782,   847,   852,   895,   854,   855,   856,
     899,   718,   900,   903,   862,   905,   798,  -932,   908,   796,
     909,   803,  -932,  -932,   801,   913,   914,   937,   808,  -932,
     809,   810,   811,   812,   813,   814,   816,   817,   818,   819,
     820,   821,   822,   823,   826,   827,   828,   836,  -932,   844,
     848,  -932,   849,   843,   850,   851,   860,  -932,   863,   871,
     874,   878,   879,   881,   882,   883,   884,   885,   886,   887,
     888,   889,  -932,   893,   897,   898,   151,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   947,   955,   958,   858,  -932,   865,   904,   912,
     915,   919,   920,   922,  -932,   923,   924,   925,   926,   927,
     929,   930,   938,   939,   941,   942,  -932,  -932,   959,   931,
     960,   945,  -932,  -932,  1011,   943,   948,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,   401,   401,   401,   401,
     401,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  1058,  1077,
     401,  1079,  1080,  1081,  1082,  1061,  1084,  1085,   401,   401,
    1064,   526,   957,  -932,  -932,  1066,   -32,  1025,  1068,  1069,
    1028,  1029,  1030,  1073,   963,  1075,  1076,  1078,  1083,  1099,
    1086,  1087,  1037,  1088,   972,  -932,   973,   974,  -932,  -932,
    -932,   976,   977,   657,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -250,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -222,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   526,
     526,   526,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
      -6,   981,   982,    -5,   983,   984,  -932,   985,   986,   987,
     988,  1120,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  -932,  1002,   754,  1003,  -932,   -22,
    1004,  1005,  1067,  1006,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  1074,  1115,  1089,
    1090,  1008,  1091,  1092,  1093,  1094,  1117,  1095,  1121,  1096,
    1122,  1097,  1098,  1100,  1123,  1101,  1009,  1102,  1124,  1103,
    1017,  -932,  1018,  1019,  1020,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  1021,   312,  1022,  -932,  1033,   444,
    -932,  -932,  -932,  -932,  -932,  -932,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    -932,  1052,  1053,  1054,  1055,  1056,  1057,  1059,  1060,  1062,
    1063,  1189,  1065,  1070,  1071,  1072,  1104,  1105,  1106,  1107,
    1108,  -932,  -932,  -932,  -932,  -932,  -932,  -203,  -932,  -932,
     890,  -932,   928,  -932,  -932,  -932,  -932,  -932,  -185,  -932,
    -932,  -932,  -932,  -932,  -184,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -143,  -932,   934,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -114,  -932,  -932,  -932,  -932,  -932,  -112,  -932,  -932,  -932,
    1191,   937,  1109,  1110,  1111,  1112,  1113,  1195,  1114,  1116,
    1118,  1119,  1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,
    1133,  1134,   966,  1135,  1136,  1137,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   -60,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,   -30,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,    -8,  -932,   154,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,   657,  -932,  -932,
    -932,    -6,  -932,    -5,   934,  -932,  1120,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   754,
    -932,   -22,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
      31,  -932,   448,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,    46,  -932,  -932,
    -932,  -932,  -932,   312,  -932,   444,   154,  -932,  1189,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,   448,  -932,  1195,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,   966,  -932,  -932,  -932,  -932,  -932,
    -932,  -932
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -932,  -932,  -932,  -885,  -344,  -931,  -430,  -932,  -932,  1138,
    -932,  -932,  -932,  -932,  1013,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  1261,  -932,
    -932,  -932,  -932,  -932,  1139,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,   497,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -166,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -151,  -932,  -932,  -144,  -932,  -932,  -932,  -932,   720,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
     -71,  -932,   835,  -932,  -932,  -932,    55,  -932,  -932,  -932,
    -932,  -932,   870,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   -52,  -932,  -932,   -49,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   815,
    -932,  -932,  -932,  -932,  -932,  -932,   784,  -932,  -932,  -932,
    -932,  -932,  -116,  -932,  -932,  -932,   771,  -932,  -932,  -932,
    -932,  -115,  -932,  -932,  -932,  -932,   692,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -117,
    -932,  -932,  -111,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   -55,  -932,
     859,  -932,  -932,  -932,  -932,  -932,  1015,  -932,  -932,  -932,
    -932,  1230,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   -29,
    -932,   989,  -932,  -932,  -932,  -932,  1170,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,   118,
    -932,  -932,  -932,   121,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,   916,  -932,  -932,  -932,  -932,  -932,   -28,  -932,
    -932,  -932,  -932,  -932,   -23,  -932,  -932,  1266,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,
    -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  -932,  1140,
    -932,  -932,  -932,  -932,  -932,  -932,  -932
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     591,   592,   743,   492,   565,  1246,  1252,   598,   278,   574,
     373,   565,   289,    67,    67,  1239,   533,   124,   501,  1240,
     362,  1191,  1192,  1193,  1194,  1195,   373,   132,   501,   278,
      47,   124,    45,    46,   133,   134,   362,   534,   135,   691,
      48,   693,   574,  1241,   492,   136,    52,  1242,   440,    68,
      68,   441,   290,   705,   137,   533,   708,  1283,   138,   139,
      69,    69,  1386,    54,   716,   140,  1387,   291,    59,   141,
     142,   143,   502,   144,   726,   727,   534,   729,    60,   145,
    1390,  1392,   502,   117,  1391,  1393,   740,   741,    63,   744,
     292,    64,   293,   442,   294,   295,   443,   123,   146,   147,
     120,   148,   131,   503,   149,   125,  1069,  1070,  1071,   126,
     504,   150,   363,   503,   247,   296,   151,   152,   153,   125,
     504,   154,  1395,   126,   155,   156,  1396,   566,   363,   279,
     734,   735,   575,   374,   566,   157,    70,    70,  1243,  1244,
    1245,   158,   159,   535,   160,   161,   162,   163,   248,   374,
     279,  1408,   812,  1410,   444,  1409,   813,  1411,   164,   280,
     249,   493,   736,   737,  1469,   575,  1470,   165,   375,   166,
     167,   445,   168,   505,   536,   169,   170,   814,   364,   171,
     280,  1471,   535,   505,   375,  1472,  1212,  1213,   250,   815,
     172,   494,   567,   285,   364,  1247,  1253,   576,   376,   567,
     440,   816,   493,   441,   873,  1462,   817,   333,   288,  1463,
     173,  1284,   174,   536,   376,  1285,   175,   331,   818,   332,
     176,   177,   178,   179,   180,   819,    76,   742,   181,   182,
     576,   820,   494,   821,   334,  1464,   360,   183,    77,  1465,
     822,   335,   336,   339,   637,   442,   638,   823,   443,   639,
     340,   341,   342,   640,   495,   568,  1473,  1467,   343,    78,
      79,  1468,   568,   586,   344,    80,   345,    81,   641,   642,
     643,   184,   346,   185,   644,   824,   891,   549,   337,   186,
     825,   865,   371,   788,   585,   187,   347,   361,   289,   348,
     188,   688,   438,   645,   530,   495,  1484,   646,   647,   446,
    1485,   680,   826,   512,   527,   349,   444,   896,   455,   781,
     590,  1503,   350,   756,   827,  1504,   828,   829,   606,   351,
     352,   353,   830,   445,   354,    82,    83,   456,   290,   648,
     355,   649,   356,   457,   357,    84,    85,   369,   370,   306,
     607,   608,   382,   291,   383,   384,   650,   609,   385,   386,
     906,   907,   908,   909,   910,    86,    87,   458,   459,   387,
     581,   388,   460,   389,   390,   391,   292,   651,   293,   392,
     294,   295,    88,    89,   393,   307,   461,   394,   395,   396,
     397,   398,   831,    90,   462,   399,   251,   400,   401,   832,
     402,   296,   403,    91,   404,   405,   463,   406,   407,   652,
    1474,   408,   833,   834,   464,   409,   410,  1081,  1321,   411,
     412,   413,   414,   835,   653,   416,   306,  1160,   418,   582,
     419,   420,   551,   421,   654,   308,   422,   423,   424,   610,
     611,   612,   465,   425,   613,   426,   427,   428,   429,   430,
     466,   614,   252,   253,   254,   255,   256,   257,   258,   259,
     431,   446,   307,  1486,   615,   616,   432,   433,   467,   434,
     435,   436,   309,   437,   310,   311,   513,   468,   469,   514,
     515,   617,   618,   516,   517,   518,   519,   520,   521,    92,
      93,    94,    95,   522,   619,  1322,  1487,   523,   524,   655,
     528,   358,   529,   260,   532,   584,   542,   620,  1488,   470,
     471,   543,   308,   656,   544,   545,   546,   547,   312,   964,
     313,  1209,   548,   552,   553,  1489,   554,  1323,   555,   556,
     557,   558,  1490,   314,   559,   560,   561,   261,  1491,   562,
    1492,   583,  1324,   587,   588,   589,   590,   593,   132,   309,
    1336,   310,   311,   594,  1493,   133,   134,   595,   596,   135,
     599,   597,  1325,  1326,   600,   601,   136,   602,   603,   472,
    1327,  1328,  1329,  1330,   604,   137,   605,   315,   678,   138,
     139,   679,   685,   776,  1331,   682,   140,  1494,   683,   684,
     141,   142,   143,   942,   144,   312,  1198,   313,   686,   690,
     145,   692,   694,  1495,  1206,  1207,   695,   696,   316,   317,
     314,   700,   697,   698,   563,   699,   262,   701,   702,   146,
     147,  1496,   148,  1497,  1498,   149,   703,  1337,   704,   706,
     711,   707,   150,   709,   710,   712,   713,   151,   152,   153,
     714,   715,   154,   717,   718,   155,   156,   719,   720,   721,
     722,   723,   724,   263,   315,   725,   157,   730,   728,  1338,
     731,   525,   158,   159,   732,   160,   161,   162,   163,   733,
     738,   742,   739,   812,  1339,   749,   745,   813,   746,   164,
     747,   748,   758,   751,   790,   316,   317,   783,   165,  1499,
     166,   167,   752,   168,  1340,  1341,   169,   170,   814,   791,
     171,   754,  1342,  1343,  1344,  1345,   755,   759,   760,  1500,
     815,   172,   761,   762,   764,   251,  1346,   792,   793,   794,
    1501,   795,   816,   765,   766,   767,   796,   817,   797,   805,
     768,   173,   769,   174,   770,   806,   771,   175,   807,   818,
     808,   176,   177,   178,   179,   180,   819,   809,   772,   181,
     182,   773,   820,   774,   821,   810,   775,   778,   183,   870,
     637,   822,   638,   875,   780,   639,   785,   786,   823,   640,
     787,   252,   253,   254,   255,   256,   257,   258,   259,   811,
     861,   867,   868,   869,   641,   642,   643,   862,   863,   864,
     644,    76,   184,   871,   185,   872,   824,   874,   876,   877,
     186,   825,   878,    77,   879,   880,   187,   881,   882,   645,
     883,   188,   884,   646,   647,   885,   886,   455,   887,   893,
     888,   898,   260,   826,    78,    79,   890,   894,   899,  1236,
      80,   900,    81,   901,   966,   827,   456,   828,   829,   902,
     903,   904,   457,   830,   905,   648,   913,   649,   928,   967,
     606,   914,   915,   916,   917,   971,   261,   918,   919,   929,
     920,   972,   650,  1099,  1084,   921,   458,   459,   922,   923,
     924,   460,   607,   608,   925,   926,   927,  1082,  1085,   609,
     930,   931,   932,   651,   933,   461,   934,   935,   936,   937,
      82,    83,   938,   462,   939,   940,   941,   944,   945,   946,
      84,    85,   947,   831,   948,   463,   949,   950,   951,   952,
     832,   953,   955,   464,   956,   652,  1087,     2,     3,   968,
      86,    87,     4,   833,   834,   957,  1279,   958,   959,   960,
     653,   961,   962,   963,   835,   262,   969,    88,    89,     5,
     654,   465,   973,     6,   970,   974,     7,   975,    90,   466,
     976,   977,   978,     8,   979,   980,   981,  1088,    91,   982,
     983,   610,   611,   612,  1397,  1398,   613,   467,   984,     9,
     985,   986,   263,   614,   987,   988,   468,   469,   989,  1080,
     990,   991,    10,    11,   992,    12,   615,   616,   993,   994,
     995,   996,   997,    13,   998,  1399,   798,   799,   800,   801,
     802,   803,   804,   617,   618,   655,   999,  1000,   470,   471,
    1001,    14,  1002,  1400,  1003,  1004,   619,  1005,  1006,   656,
    1007,  1401,    15,  1030,    16,  1053,  1054,  1055,  1056,   620,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1089,
      17,  1402,  1066,  1067,    92,    93,    94,    95,  1068,  1074,
    1075,  1076,  1077,  1078,  1079,  1090,  1092,    18,  1086,  1083,
    1091,  1093,  1094,  1095,  1096,  1097,  1098,  1100,   472,  1403,
    1101,  1102,  1103,  1104,  1106,  1105,  1107,  1404,  1108,  1109,
    1110,  1111,  1112,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
      19,  1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,    20,
      21,  1130,  1131,  1132,    22,    23,  1008,  1009,  1010,  1011,
    1012,  1133,  1013,  1014,  1162,  1015,  1016,  1017,  1405,  1134,
    1018,  1137,  1163,  1135,  1136,  1164,  1184,  1186,  1138,  1139,
    1019,  1020,  1021,  1165,  1022,  1023,  1024,  1406,  1140,  1025,
    1166,  1142,  1026,  1027,  1031,  1032,  1033,  1034,  1035,  1143,
    1036,  1037,  1144,  1038,  1039,  1040,  1145,  1146,  1041,  1147,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1042,  1043,
    1044,  1157,  1045,  1046,  1047,  1158,  1159,  1048,  1188,  1167,
    1049,  1050,  1437,  1438,  1439,  1440,  1441,  1168,  1442,  1443,
    1169,  1444,  1445,  1446,  1170,  1171,  1447,  1172,  1173,  1174,
    1175,  1176,  1177,  1196,  1178,  1179,  1448,  1449,  1450,  1185,
    1451,  1452,  1453,  1180,  1181,  1454,  1182,  1183,  1455,  1456,
    1187,  1189,  1197,  1190,  1199,  1200,  1201,  1202,  1203,  1204,
    1205,  1208,  1210,  1211,  1214,  1215,  1216,  1217,  1218,  1219,
    1220,  1221,  1222,  1223,  1226,  1224,  1229,  1231,  1232,  1233,
    1225,  1234,  1235,  1227,  1228,  1230,  1250,  1251,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1282,  1288,
    1289,  1290,  1294,  1293,  1302,  1291,  1297,  1312,  1304,  1306,
    1310,  1314,  1316,  1317,  1318,  1319,  1320,  1334,  1295,  1296,
    1298,  1299,  1300,  1301,  1303,  1305,  1307,  1308,  1335,  1309,
    1311,  1313,  1315,  1349,  1350,  1351,  1352,  1353,  1354,  1355,
    1356,  1357,  1358,  1359,  1360,  1361,  1362,  1363,  1364,  1365,
    1366,  1367,  1368,  1373,  1369,  1370,  1412,  1371,  1372,  1419,
    1377,   564,   338,  1161,  1510,  1378,  1379,  1380,  1511,  1509,
    1482,   943,   789,   777,  1480,  1479,  1413,  1505,   897,   965,
    1506,  1508,   866,   892,  1481,  1507,   782,   372,  1476,   439,
    1389,  1388,   359,   757,     0,  1478,     0,   689,  1477,  1381,
    1382,  1383,  1384,  1385,  1414,  1415,  1416,  1417,  1418,  1423,
     681,  1424,     0,  1425,  1426,     0,     0,     0,     0,     0,
    1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,
    1459,  1460,  1461,   526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   550
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-932)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     344,   345,   432,     1,     1,    11,    11,   351,     1,     1,
       1,     1,     1,     1,     1,   265,     1,     1,     1,   269,
       1,   906,   907,   908,   909,   910,     1,     1,     1,     1,
     267,     1,   265,   266,     8,     9,     1,    22,    12,   383,
     267,   385,     1,   265,     1,    19,   267,   269,     1,    37,
      37,     4,    41,   397,    28,     1,   400,    79,    32,    33,
      48,    48,   265,   267,   408,    39,   269,    56,   267,    43,
      44,    45,    55,    47,   418,   419,    22,   421,   267,    53,
     265,   265,    55,   157,   269,   269,   430,   431,   267,   433,
      79,   267,    81,    46,    83,    84,    49,   267,    72,    73,
     157,    75,   267,    86,    78,    89,    14,    15,    16,    93,
      93,    85,    93,    86,   267,   104,    90,    91,    92,    89,
      93,    95,   265,    93,    98,    99,   269,   124,    93,   122,
     199,   200,   124,   124,   124,   109,   124,   124,  1069,  1070,
    1071,   115,   116,   128,   118,   119,   120,   121,   267,   124,
     122,   265,     1,   265,   107,   269,     5,   269,   132,   152,
     267,   159,   199,   200,    10,   124,    12,   141,   159,   143,
     144,   124,   146,   156,   159,   149,   150,    26,   159,   153,
     152,    27,   128,   156,   159,    31,   218,   219,   267,    38,
     164,   189,   189,   157,   159,   201,   201,   189,   189,   189,
       1,    50,   159,     4,   548,   265,    55,   265,   267,   269,
     184,   233,   186,   159,   189,   237,   190,   267,    67,   267,
     194,   195,   196,   197,   198,    74,     1,   135,   202,   203,
     189,    80,   189,    82,   268,   265,   267,   211,    13,   269,
      89,   268,   268,   268,     1,    46,     3,    96,    49,     6,
     268,   268,   268,    10,   252,   252,   102,   265,   268,    34,
      35,   269,   252,   135,   268,    40,   268,    42,    25,    26,
      27,   245,   268,   247,    31,   124,   266,   266,   266,   253,
     129,   266,   266,   266,   199,   259,   268,   267,     1,   268,
     264,   266,   266,    50,   266,   252,   265,    54,    55,   252,
     269,   266,   151,   265,   265,   268,   107,   266,     1,   266,
     135,   265,   268,   266,   163,   269,   165,   166,     1,   268,
     268,   268,   171,   124,   268,   100,   101,    20,    41,    86,
     268,    88,   268,    26,   268,   110,   111,   268,   268,     1,
      23,    24,   268,    56,   268,   268,   103,    30,   268,   268,
     175,   176,   177,   178,   179,   130,   131,    50,    51,   268,
     157,   268,    55,   268,   268,   268,    79,   124,    81,   268,
      83,    84,   147,   148,   268,    37,    69,   268,   268,   268,
     268,   268,   231,   158,    77,   268,     1,   268,   268,   238,
     268,   104,   268,   168,   268,   268,    89,   268,   268,   156,
     246,   268,   251,   252,    97,   268,   268,   751,    96,   268,
     268,   268,   268,   262,   171,   268,     1,   266,   268,   157,
     268,   268,   265,   268,   181,    87,   268,   268,   268,   112,
     113,   114,   125,   268,   117,   268,   268,   268,   268,   268,
     133,   124,    57,    58,    59,    60,    61,    62,    63,    64,
     268,   252,    37,     5,   137,   138,   268,   268,   151,   268,
     268,   268,   124,   268,   126,   127,   268,   160,   161,   268,
     268,   154,   155,   268,   268,   268,   268,   268,   268,   254,
     255,   256,   257,   268,   167,   173,    38,   268,   268,   246,
     268,   266,   268,   108,   267,   265,   268,   180,    50,   192,
     193,   268,    87,   260,   268,   268,   268,   268,   170,   266,
     172,   941,   268,   268,   268,    67,   268,   205,   268,   268,
     268,   268,    74,   185,   268,   268,   268,   142,    80,   268,
      82,   157,   220,   135,   199,   199,   135,   135,     1,   124,
      96,   126,   127,   135,    96,     8,     9,   199,   199,    12,
     199,   135,   240,   241,   199,   199,    19,   199,   199,   252,
     248,   249,   250,   251,   199,    28,   265,   229,   268,    32,
      33,   268,   268,   266,   262,   157,    39,   129,   157,   265,
      43,    44,    45,   266,    47,   170,   930,   172,   268,   199,
      53,   199,   135,   145,   938,   939,   157,   135,   260,   261,
     185,   135,   199,   199,   266,   199,   221,   157,   199,    72,
      73,   163,    75,   165,   166,    78,   135,   173,   135,   135,
     135,   199,    85,   199,   199,   157,   199,    90,    91,    92,
     135,   135,    95,   135,   157,    98,    99,   135,   135,   199,
     199,   268,   199,   258,   229,   268,   109,   157,   199,   205,
     199,   266,   115,   116,   199,   118,   119,   120,   121,   199,
     199,   135,   199,     1,   220,   265,   199,     5,   199,   132,
     199,   199,   265,   268,   157,   260,   261,   265,   141,   231,
     143,   144,   268,   146,   240,   241,   149,   150,    26,   157,
     153,   268,   248,   249,   250,   251,   268,   268,   268,   251,
      38,   164,   268,   268,   268,     1,   262,   157,   157,   157,
     262,   157,    50,   268,   268,   268,   157,    55,   157,   157,
     268,   184,   268,   186,   268,   157,   268,   190,   199,    67,
     265,   194,   195,   196,   197,   198,    74,   157,   268,   202,
     203,   268,    80,   268,    82,   157,   268,   268,   211,   157,
       1,    89,     3,   157,   268,     6,   268,   268,    96,    10,
     268,    57,    58,    59,    60,    61,    62,    63,    64,   265,
     265,   199,   199,   199,    25,    26,    27,   268,   268,   268,
      31,     1,   245,   199,   247,   199,   124,   265,   199,   157,
     253,   129,   157,    13,   157,   157,   259,   157,   157,    50,
     135,   264,   157,    54,    55,   157,   265,     1,   265,   265,
     268,   265,   108,   151,    34,    35,   268,   268,   265,   162,
      40,   265,    42,   265,   157,   163,    20,   165,   166,   265,
     265,   265,    26,   171,   265,    86,   265,    88,   268,   157,
       1,   265,   265,   265,   265,   157,   142,   265,   265,   268,
     265,   157,   103,   135,   157,   265,    50,    51,   265,   265,
     265,    55,    23,    24,   265,   265,   265,   199,   157,    30,
     268,   268,   268,   124,   268,    69,   268,   268,   268,   268,
     100,   101,   268,    77,   268,   268,   268,   265,   268,   268,
     110,   111,   268,   231,   268,    89,   268,   268,   268,   268,
     238,   268,   268,    97,   268,   156,   199,     0,     1,   265,
     130,   131,     5,   251,   252,   268,   162,   268,   268,   268,
     171,   268,   268,   268,   262,   221,   265,   147,   148,    22,
     181,   125,   268,    26,   265,   265,    29,   265,   158,   133,
     265,   265,   265,    36,   265,   265,   265,   157,   168,   265,
     265,   112,   113,   114,    20,    21,   117,   151,   265,    52,
     265,   265,   258,   124,   265,   265,   160,   161,   265,   268,
     265,   265,    65,    66,   265,    68,   137,   138,   265,   265,
     265,   265,   265,    76,   265,    51,   222,   223,   224,   225,
     226,   227,   228,   154,   155,   246,   265,   265,   192,   193,
     265,    94,   265,    69,   265,   265,   167,   265,   265,   260,
     265,    77,   105,   265,   107,   265,   265,   265,   265,   180,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   199,
     123,    97,   265,   265,   254,   255,   256,   257,   265,   265,
     265,   265,   265,   265,   265,   199,   199,   140,   265,   268,
     268,   199,   157,   199,   199,   199,   157,   157,   252,   125,
     157,   199,   157,   265,   268,   157,   157,   133,   265,   268,
     157,   157,   135,   265,   265,   265,   265,   265,   265,   265,
     173,   265,   265,   265,   265,   265,   265,   265,   265,   182,
     183,   265,   265,   265,   187,   188,   206,   207,   208,   209,
     210,   265,   212,   213,   157,   215,   216,   217,   174,   265,
     220,   268,   157,   265,   265,   157,   157,   157,   268,   268,
     230,   231,   232,   265,   234,   235,   236,   193,   268,   239,
     265,   268,   242,   243,   206,   207,   208,   209,   210,   268,
     212,   213,   268,   215,   216,   217,   268,   268,   220,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   230,   231,
     232,   268,   234,   235,   236,   268,   268,   239,   157,   265,
     242,   243,   206,   207,   208,   209,   210,   265,   212,   213,
     265,   215,   216,   217,   265,   265,   220,   265,   265,   265,
     265,   265,   265,   135,   265,   265,   230,   231,   232,   268,
     234,   235,   236,   265,   265,   239,   265,   265,   242,   243,
     265,   268,   135,   265,   135,   135,   135,   135,   157,   135,
     135,   157,   265,   157,   199,   157,   157,   199,   199,   199,
     157,   268,   157,   157,   135,   157,   199,   265,   265,   265,
     157,   265,   265,   157,   157,   157,   265,   265,   265,   265,
     265,   265,   265,   265,   134,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   204,   157,   199,   157,   269,   268,   268,   157,   157,
     157,   157,   265,   265,   265,   265,   265,   265,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   265,   199,
     199,   199,   199,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   134,   265,   265,   135,   265,   265,   134,
     265,   318,    71,   836,  1485,   265,   265,   265,  1504,  1483,
    1411,   621,   507,   473,  1396,  1394,  1291,  1463,   577,   657,
    1465,  1468,   537,   569,  1409,  1466,   497,   127,  1387,   189,
    1242,  1240,    96,   447,    -1,  1393,    -1,   378,  1391,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     365,   265,    -1,   265,   265,    -1,    -1,    -1,    -1,    -1,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   271,     0,     1,     5,    22,    26,    29,    36,    52,
      65,    66,    68,    76,    94,   105,   107,   123,   140,   173,
     182,   183,   187,   188,   272,   277,   282,   296,   302,   317,
     355,   375,   389,   416,   423,   433,   442,   473,   483,   489,
     494,   504,   569,   585,   607,   265,   266,   267,   267,   356,
     443,   484,   267,   495,   267,   570,   390,   474,   376,   267,
     267,   318,   417,   267,   267,   424,   434,     1,    37,    48,
     124,   297,   298,   299,   300,   301,     1,    13,    34,    35,
      40,    42,   100,   101,   110,   111,   130,   131,   147,   148,
     158,   168,   254,   255,   256,   257,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   157,   357,   361,
     157,   444,   448,   267,     1,    89,    93,   490,   491,   492,
     493,   267,     1,     8,     9,    12,    19,    28,    32,    33,
      39,    43,    44,    45,    47,    53,    72,    73,    75,    78,
      85,    90,    91,    92,    95,    98,    99,   109,   115,   116,
     118,   119,   120,   121,   132,   141,   143,   144,   146,   149,
     150,   153,   164,   184,   186,   190,   194,   195,   196,   197,
     198,   202,   203,   211,   245,   247,   253,   259,   264,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   560,   564,   565,   566,   567,   568,   267,   267,   267,
     267,     1,    57,    58,    59,    60,    61,    62,    63,    64,
     108,   142,   221,   258,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,     1,   122,
     152,   278,   279,   280,   281,   157,   319,   323,   267,     1,
      41,    56,    79,    81,    83,    84,   104,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     1,    37,    87,   124,
     126,   127,   170,   172,   185,   229,   260,   261,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   267,   267,   265,   268,   268,   268,   266,   298,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   266,   587,
     267,   267,     1,    93,   159,   485,   486,   487,   488,   268,
     268,   266,   491,     1,   124,   159,   189,   496,   500,   501,
     502,   503,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   561,   268,   557,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   266,   506,
       1,     4,    46,    49,   107,   124,   252,   571,   572,   573,
     574,   575,   579,   580,   581,     1,    20,    26,    50,    51,
      55,    69,    77,    89,    97,   125,   133,   151,   160,   161,
     192,   193,   252,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,     1,   159,   189,   252,   475,   479,   480,   481,
     482,     1,    55,    86,    93,   156,   377,   381,   382,   383,
     387,   388,   265,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   266,   304,   265,   268,   268,
     266,   279,   267,     1,    22,   128,   159,   418,   419,   420,
     421,   422,   268,   268,   268,   268,   268,   268,   268,   266,
     609,   265,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   266,   284,     1,   124,   189,   252,   425,
     426,   427,   428,   429,     1,   124,   189,   435,   436,   437,
     438,   157,   157,   157,   265,   199,   135,   135,   199,   199,
     135,   274,   274,   135,   135,   199,   199,   135,   274,   199,
     199,   199,   199,   199,   199,   265,     1,    23,    24,    30,
     112,   113,   114,   117,   124,   137,   138,   154,   155,   167,
     180,   358,   359,   360,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     1,     3,     6,
      10,    25,    26,    27,    31,    50,    54,    55,    86,    88,
     103,   124,   156,   171,   181,   246,   260,   445,   446,   447,
     449,   450,   451,   452,   453,   454,   455,   456,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   268,   268,
     266,   486,   157,   157,   265,   268,   268,   497,   266,   501,
     199,   274,   199,   274,   135,   157,   135,   199,   199,   199,
     135,   157,   199,   135,   135,   274,   135,   199,   274,   199,
     199,   135,   157,   199,   135,   135,   274,   135,   157,   135,
     135,   199,   199,   268,   199,   268,   274,   274,   199,   274,
     157,   199,   199,   199,   199,   200,   199,   200,   199,   199,
     274,   274,   135,   276,   274,   199,   199,   199,   199,   265,
     582,   268,   268,   576,   268,   268,   266,   572,   265,   268,
     268,   268,   268,   400,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   266,   392,   268,   476,
     268,   266,   480,   265,   378,   268,   268,   268,   266,   382,
     157,   157,   157,   157,   157,   157,   157,   157,   222,   223,
     224,   225,   226,   227,   228,   157,   157,   199,   265,   157,
     157,   265,     1,     5,    26,    38,    50,    55,    67,    74,
      80,    82,    89,    96,   124,   129,   151,   163,   165,   166,
     171,   231,   238,   251,   252,   262,   320,   321,   322,   324,
     325,   326,   327,   328,   329,   330,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   265,   268,   268,   268,   266,   419,   199,   199,   199,
     157,   199,   199,   274,   265,   157,   199,   157,   157,   157,
     157,   157,   157,   135,   157,   157,   265,   265,   268,   430,
     268,   266,   426,   265,   268,   439,   266,   436,   265,   265,
     265,   265,   265,   265,   265,   265,   175,   176,   177,   178,
     179,   273,   274,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   266,   359,   265,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   457,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   266,   446,   157,   157,   265,   265,
     265,   157,   157,   268,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   206,   207,
     208,   209,   210,   212,   213,   215,   216,   217,   220,   230,
     231,   232,   234,   235,   236,   239,   242,   243,   562,   563,
     265,   206,   207,   208,   209,   210,   212,   213,   215,   216,
     217,   220,   230,   231,   232,   234,   235,   236,   239,   242,
     243,   558,   559,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,    14,
      15,    16,   275,   276,   265,   265,   265,   265,   265,   265,
     268,   274,   199,   268,   157,   157,   265,   199,   157,   199,
     199,   268,   199,   199,   157,   199,   199,   199,   157,   135,
     157,   157,   199,   157,   265,   157,   268,   157,   265,   268,
     157,   157,   135,   385,   386,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   268,   268,   268,
     268,   349,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   331,   268,   268,   268,
     266,   321,   157,   157,   157,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   157,   268,   157,   265,   157,   268,
     265,   273,   273,   273,   273,   273,   135,   135,   274,   135,
     135,   135,   135,   157,   135,   135,   274,   274,   157,   276,
     265,   157,   218,   219,   199,   157,   157,   199,   199,   199,
     157,   268,   157,   157,   157,   157,   135,   157,   157,   199,
     157,   265,   265,   265,   265,   265,   162,   498,   499,   265,
     269,   265,   269,   275,   275,   275,    11,   201,   583,   584,
     265,   265,    11,   201,   577,   578,   265,   265,   265,   265,
     265,   265,   134,   401,   402,   404,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   162,
     477,   478,   265,    79,   233,   237,   379,   380,   265,   265,
     204,   269,   384,   199,   157,   199,   199,   268,   199,   199,
     199,   199,   157,   199,   157,   199,   157,   199,   199,   199,
     157,   199,   268,   199,   157,   199,   265,   265,   265,   265,
     265,    96,   173,   205,   220,   240,   241,   248,   249,   250,
     251,   262,   431,   432,   265,   265,    96,   173,   205,   220,
     240,   241,   248,   249,   250,   251,   262,   440,   441,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   134,   458,   459,   461,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   269,   563,   559,
     265,   269,   265,   269,   403,   265,   269,    20,    21,    51,
      69,    77,    97,   125,   133,   174,   193,   405,   265,   269,
     265,   269,   135,   386,   265,   265,   265,   265,   265,   134,
     350,   351,   353,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   206,   207,   208,
     209,   210,   212,   213,   215,   216,   217,   220,   230,   231,
     232,   234,   235,   236,   239,   242,   243,   332,   333,   265,
     265,   265,   265,   269,   265,   269,   460,   265,   269,    10,
      12,    27,    31,   102,   246,   462,   499,   584,   578,   405,
     402,   478,   380,   352,   265,   269,     5,    38,    50,    67,
      74,    80,    82,    96,   129,   145,   163,   165,   166,   231,
     251,   262,   354,   265,   269,   432,   441,   462,   459,   354,
     351,   333
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 26:
/* Line 1792 of yacc.c  */
#line 433 "ircd_parser.y"
    { (yyval.number) = 0; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 435 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (2)].number) + (yyvsp[(2) - (2)].number);
		}
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 439 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (3)].number) + (yyvsp[(3) - (3)].number);
		}
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 443 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (3)].number) * 60 + (yyvsp[(3) - (3)].number);
		}
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 447 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (3)].number) * 60 * 60 + (yyvsp[(3) - (3)].number);
		}
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 451 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (3)].number) * 60 * 60 * 24 + (yyvsp[(3) - (3)].number);
		}
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 455 "ircd_parser.y"
    {
			(yyval.number) = (yyvsp[(1) - (3)].number) * 60 * 60 * 24 * 7 + (yyvsp[(3) - (3)].number);
		}
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 460 "ircd_parser.y"
    { (yyval.number) = 0; }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 461 "ircd_parser.y"
    { (yyval.number) = (yyvsp[(1) - (2)].number) + (yyvsp[(2) - (2)].number); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 462 "ircd_parser.y"
    { (yyval.number) = (yyvsp[(1) - (3)].number) + (yyvsp[(3) - (3)].number); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 463 "ircd_parser.y"
    { (yyval.number) = (yyvsp[(1) - (3)].number) * 1024 + (yyvsp[(3) - (3)].number); }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 464 "ircd_parser.y"
    { (yyval.number) = (yyvsp[(1) - (3)].number) * 1024 * 1024 + (yyvsp[(3) - (3)].number); }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 478 "ircd_parser.y"
    {
#ifndef STATIC_MODULES /* NOOP in the static case */
  if (ypass == 2)
  {
    /* I suppose we should just ignore it if it is already loaded(since
     * otherwise we would flood the opers on rehash) -A1kmm.
     */
    add_conf_module(yylval.string);
  }
#endif
}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 491 "ircd_parser.y"
    {
#ifndef STATIC_MODULES
  if (ypass == 2)
    mod_add_path(yylval.string);
#endif
}
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 515 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 2 && ServerInfo.ctx) 
  {
    if (!ServerInfo.rsa_private_key_file)
    {
      yyerror("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(ServerInfo.ctx,
      yylval.string) <= 0)
    {
      yyerror(ERR_lib_error_string(ERR_get_error()));
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(ServerInfo.ctx,
      ServerInfo.rsa_private_key_file, SSL_FILETYPE_PEM) <= 0)
    {
      yyerror(ERR_lib_error_string(ERR_get_error()));
      break;
    }

    if (!SSL_CTX_check_private_key(ServerInfo.ctx))
    {
      yyerror("RSA private key does not match the SSL certificate public key!");
      break;
    }
  }
#endif
}
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 549 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 1)
  {
    BIO *file;

    if (ServerInfo.rsa_private_key)
    {
      RSA_free(ServerInfo.rsa_private_key);
      ServerInfo.rsa_private_key = NULL;
    }

    if (ServerInfo.rsa_private_key_file)
    {
      MyFree(ServerInfo.rsa_private_key_file);
      ServerInfo.rsa_private_key_file = NULL;
    }

    DupString(ServerInfo.rsa_private_key_file, yylval.string);

    if ((file = BIO_new_file(yylval.string, "r")) == NULL)
    {
      yyerror("File open failed, ignoring");
      break;
    }

    ServerInfo.rsa_private_key = (RSA *)PEM_read_bio_RSAPrivateKey(file, NULL,
      0, NULL);

    (void)BIO_set_close(file, BIO_CLOSE);
    BIO_free(file);

    if (ServerInfo.rsa_private_key == NULL)
    {
      yyerror("Couldn't extract key, ignoring");
      break;
    }

    if (!RSA_check_key(ServerInfo.rsa_private_key))
    {
      RSA_free(ServerInfo.rsa_private_key);
      ServerInfo.rsa_private_key = NULL;

      yyerror("Invalid key, ignoring");
      break;
    }

    /* require 2048 bit (256 byte) key */
    if (RSA_size(ServerInfo.rsa_private_key) != 256)
    {
      RSA_free(ServerInfo.rsa_private_key);
      ServerInfo.rsa_private_key = NULL;

      yyerror("Not a 2048 bit key, ignoring");
    }
  }
#endif
}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 609 "ircd_parser.y"
    {
  /* this isn't rehashable */
  if (ypass == 2)
  {
    if (ServerInfo.name == NULL)
    {
      /* the ircd will exit() in main() if we dont set one */
      if (strlen(yylval.string) <= HOSTLEN)
        DupString(ServerInfo.name, yylval.string);
    }
  }
}
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 623 "ircd_parser.y"
    {
  /* this isn't rehashable */
  if (ypass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      DupString(ServerInfo.sid, yylval.string);
    else
    {
      ilog(L_ERROR, "Ignoring config file entry SID -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 638 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ServerInfo.description);
    DupString(ServerInfo.description,yylval.string);
  }
}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 647 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      p = '\0';

    MyFree(ServerInfo.network_name);
    DupString(ServerInfo.network_name, yylval.string);
  }
}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 661 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ServerInfo.network_desc);
    DupString(ServerInfo.network_desc, yylval.string);
  }
}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 670 "ircd_parser.y"
    {
  if (ypass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (irc_getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(L_ERROR, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      irc_freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 698 "ircd_parser.y"
    {
#ifdef IPV6
  if (ypass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (irc_getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(L_ERROR, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      irc_freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 728 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    recalc_fdlimit(NULL);

    if ((yyvsp[(3) - (4)].number) < MAXCLIENTS_MIN)
    {
      char buf[IRCD_BUFSIZE];
      ircsprintf(buf, "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
      yyerror(buf);
    }
    else if ((yyvsp[(3) - (4)].number) > MAXCLIENTS_MAX)
    {
      char buf[IRCD_BUFSIZE];
      ircsprintf(buf, "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
      yyerror(buf);
    }
    else
      ServerInfo.max_clients = (yyvsp[(3) - (4)].number);
  }
}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 751 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
    {
      /* Don't become a hub if we have a lazylink active. */
      if (!ServerInfo.hub && uplink && IsCapable(uplink, CAP_LL))
      {
        sendto_realops_flags(UMODE_ALL, L_ALL, me.name, &me, NULL,
                             "Ignoring config file line hub=yes; "
                             "due to active LazyLink (%s)", uplink->name);
      }
      else
      {
        ServerInfo.hub = 1;
        uplink = NULL;
        delete_capability("HUB");
        add_capability("HUB", CAP_HUB, 1);
      }
    }
    else if (ServerInfo.hub)
    {
      dlink_node *ptr = NULL;

      ServerInfo.hub = 0;
      delete_capability("HUB");

      /* Don't become a leaf if we have a lazylink active. */
      DLINK_FOREACH(ptr, serv_list.head)
      {
        const struct Client *acptr = ptr->data;
        if (MyConnect(acptr) && IsCapable(acptr, CAP_LL))
        {
          sendto_realops_flags(UMODE_ALL, L_ALL, me.name, &me, NULL,
                               "Ignoring config file line hub=no; "
                               "due to active LazyLink (%s)",
                               acptr->name);
          add_capability("HUB", CAP_HUB, 1);
          ServerInfo.hub = 1;
          break;
        }
      }
    }
  }
}
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 807 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(AdminInfo.name);
    DupString(AdminInfo.name, yylval.string);
  }
}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 816 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(AdminInfo.email);
    DupString(AdminInfo.email, yylval.string);
  }
}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 825 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(AdminInfo.description);
    DupString(AdminInfo.description, yylval.string);
  }
}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 852 "ircd_parser.y"
    {
                        }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 856 "ircd_parser.y"
    {
                        }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 860 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.userlog, yylval.string,
            sizeof(ConfigLoggingEntry.userlog));
}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 867 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.failed_operlog, yylval.string,
            sizeof(ConfigLoggingEntry.failed_operlog));
}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 874 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.operlog, yylval.string,
            sizeof(ConfigLoggingEntry.operlog));
}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 881 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.operspylog, yylval.string,
            sizeof(ConfigLoggingEntry.operspylog));
}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 888 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.glinelog, yylval.string,
            sizeof(ConfigLoggingEntry.glinelog));
}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 895 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.klinelog, yylval.string,
            sizeof(ConfigLoggingEntry.klinelog));
}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 902 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.ioerrlog, yylval.string,
            sizeof(ConfigLoggingEntry.ioerrlog));
}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 909 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(ConfigLoggingEntry.killlog, yylval.string,
            sizeof(ConfigLoggingEntry.killlog));
}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 916 "ircd_parser.y"
    { 
  if (ypass == 2)
    set_log_level(L_CRIT);
}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 920 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_ERROR);
}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 924 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_WARN);
}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 928 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_NOTICE);
}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 932 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_TRACE);
}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 936 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_INFO);
}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 940 "ircd_parser.y"
    {
  if (ypass == 2)
    set_log_level(L_DEBUG);
}
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 946 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 955 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(OPER_TYPE);
    yy_aconf = map_to_conf(yy_conf);
    SetConfEncrypted(yy_aconf); /* Yes, the default is encrypted */
  }
  else
  {
    MyFree(class_name);
    class_name = NULL;
  }
}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 968 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp;
    dlink_node *ptr;
    dlink_node *next_ptr;

    conf_add_class_to_conf(yy_conf, class_name);

    /* Now, make sure there is a copy of the "base" given oper
     * block in each of the collected copies
     */

    DLINK_FOREACH_SAFE(ptr, next_ptr, col_conf_list.head)
    {
      struct AccessItem *new_aconf;
      struct ConfItem *new_conf;
      yy_tmp = ptr->data;

      new_conf = make_conf_item(OPER_TYPE);
      new_aconf = (struct AccessItem *)map_to_conf(new_conf);

      new_aconf->flags = yy_aconf->flags;

      if (yy_conf->name != NULL)
        DupString(new_conf->name, yy_conf->name);
      if (yy_tmp->user != NULL)
        DupString(new_aconf->user, yy_tmp->user);
      else
        DupString(new_aconf->user, "*");
      if (yy_tmp->host != NULL)
        DupString(new_aconf->host, yy_tmp->host);
      else
        DupString(new_aconf->host, "*");
      conf_add_class_to_conf(new_conf, class_name);
      if (yy_aconf->passwd != NULL)
        DupString(new_aconf->passwd, yy_aconf->passwd);

      new_aconf->port = yy_aconf->port;
#ifdef HAVE_LIBCRYPTO
      if (yy_aconf->rsa_public_key_file != NULL)
      {
        BIO *file;

        DupString(new_aconf->rsa_public_key_file,
            yy_aconf->rsa_public_key_file);

        file = BIO_new_file(yy_aconf->rsa_public_key_file, "r");
        new_aconf->rsa_public_key = (RSA *)PEM_read_bio_RSA_PUBKEY(file, 
            NULL, 0, NULL);
        (void)BIO_set_close(file, BIO_CLOSE);
        BIO_free(file);
      }

      if (yy_aconf->certfp != NULL)
      {
        new_aconf->certfp = MyMalloc(SHA_DIGEST_LENGTH);
        memcpy(new_aconf->certfp, yy_aconf->certfp, SHA_DIGEST_LENGTH);
      }
#endif

#ifdef HAVE_LIBCRYPTO
      if (yy_tmp->name && (yy_tmp->passwd || yy_aconf->rsa_public_key)
	  && yy_tmp->host)
#else
      if (yy_tmp->name && yy_tmp->passwd && yy_tmp->host)
#endif
      {
        conf_add_class_to_conf(new_conf, class_name);
	if (yy_tmp->name != NULL)
	  DupString(new_conf->name, yy_tmp->name);
      }

      dlinkDelete(&yy_tmp->node, &col_conf_list);
      free_collect_item(yy_tmp);
    }

    yy_conf = NULL;
    yy_aconf = NULL;


    MyFree(class_name);
    class_name = NULL;
  }
}
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1066 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (strlen(yylval.string) > OPERNICKLEN)
      yylval.string[OPERNICKLEN] = '\0';

    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1078 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (strlen(yylval.string) > OPERNICKLEN)
      yylval.string[OPERNICKLEN] = '\0';

    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1090 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = userbuf;
    nuh.hostptr  = hostbuf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(userbuf);
    nuh.hostsize = sizeof(hostbuf);

    split_nuh(&nuh);

    if (yy_aconf->user == NULL)
    {
      DupString(yy_aconf->user, userbuf);
      DupString(yy_aconf->host, hostbuf);
    }
    else
    {
      struct CollectItem *yy_tmp = MyMalloc(sizeof(struct CollectItem));

      DupString(yy_tmp->user, userbuf);
      DupString(yy_tmp->host, hostbuf);

      dlinkAdd(yy_tmp, &yy_tmp->node, &col_conf_list);
    }
  }
}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1124 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    char tmp[SHA_DIGEST_LENGTH];
    
    if(yy_aconf->certfp != NULL)
      MyFree(yy_aconf->certfp);

    if(base16_decode(tmp, SHA_DIGEST_LENGTH, yylval.string, strlen(yylval.string)) != 0)
    {
      yyerror("Invalid client certificate fingerprint provided. Ignoring");
      break;
    }
    yy_aconf->certfp = MyMalloc(SHA_DIGEST_LENGTH);
    memcpy(yy_aconf->certfp, tmp, SHA_DIGEST_LENGTH);
  }
}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1143 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yy_aconf->passwd != NULL)
      memset(yy_aconf->passwd, 0, strlen(yy_aconf->passwd));

    MyFree(yy_aconf->passwd);
    DupString(yy_aconf->passwd, yylval.string);
  }
}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1155 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      SetConfEncrypted(yy_aconf);
    else
      ClearConfEncrypted(yy_aconf);
  }
}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1166 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 2)
  {
    BIO *file;

    if (yy_aconf->rsa_public_key != NULL)
    {
      RSA_free(yy_aconf->rsa_public_key);
      yy_aconf->rsa_public_key = NULL;
    }

    if (yy_aconf->rsa_public_key_file != NULL)
    {
      MyFree(yy_aconf->rsa_public_key_file);
      yy_aconf->rsa_public_key_file = NULL;
    }

    DupString(yy_aconf->rsa_public_key_file, yylval.string);
    file = BIO_new_file(yylval.string, "r");

    if (file == NULL)
    {
      yyerror("Ignoring rsa_public_key_file -- file doesn't exist");
      break;
    }

    yy_aconf->rsa_public_key = (RSA *)PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL);

    if (yy_aconf->rsa_public_key == NULL)
    {
      yyerror("Ignoring rsa_public_key_file -- Key invalid; check key syntax.");
      break;
    }

    (void)BIO_set_close(file, BIO_CLOSE);
    BIO_free(file);
  }
#endif /* HAVE_LIBCRYPTO */
}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1208 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(class_name);
    DupString(class_name, yylval.string);
  }
}
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1217 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes = 0;
}
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1224 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_BOTS;
}
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1228 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_CCONN;
}
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1232 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_CCONN_FULL;
}
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1236 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_DEAF;
}
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1240 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_DEBUG;
}
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1244 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_FULL;
}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1248 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_SKILL;
}
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1252 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_NCHANGE;
}
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1256 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_REJ;
}
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1260 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_UNAUTH;
}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1264 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_SPY;
}
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1268 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_EXTERNAL;
}
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1272 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_OPERWALL;
}
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1276 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_SERVNOTICE;
}
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1280 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_INVISIBLE;
}
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1284 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_WALLOP;
}
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1288 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_SOFTCALLERID;
}
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1292 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_CALLERID;
}
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1296 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_LOCOPS;
}
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1300 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->modes |= UMODE_GOD;
}
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1306 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_GLOBAL_KILL;
    else
      yy_aconf->port &= ~OPER_FLAG_GLOBAL_KILL;
  }
}
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1317 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_REMOTE;
    else
      yy_aconf->port &= ~OPER_FLAG_REMOTE; 
  }
}
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1328 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_REMOTEBAN;
    else
      yy_aconf->port &= ~OPER_FLAG_REMOTEBAN;
  }
}
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1339 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_K;
    else
      yy_aconf->port &= ~OPER_FLAG_K;
  }
}
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1350 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_X;
    else
      yy_aconf->port &= ~OPER_FLAG_X;
  }
}
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1361 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_UNKLINE;
    else
      yy_aconf->port &= ~OPER_FLAG_UNKLINE; 
  }
}
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1372 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_GLINE;
    else
      yy_aconf->port &= ~OPER_FLAG_GLINE;
  }
}
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1383 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_N;
    else
      yy_aconf->port &= ~OPER_FLAG_N;
  }
}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1394 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_DIE;
    else
      yy_aconf->port &= ~OPER_FLAG_DIE;
  }
}
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1405 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_REHASH;
    else
      yy_aconf->port &= ~OPER_FLAG_REHASH;
  }
}
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1416 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_ADMIN;
    else
      yy_aconf->port &= ~OPER_FLAG_ADMIN;
  }
}
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1427 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_HIDDEN_ADMIN;
    else
      yy_aconf->port &= ~OPER_FLAG_HIDDEN_ADMIN;
  }
}
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1438 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_HIDDEN_OPER;
    else
      yy_aconf->port &= ~OPER_FLAG_HIDDEN_OPER;
  }
}
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1449 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->port |= OPER_FLAG_OPERWALL;
    else
      yy_aconf->port &= ~OPER_FLAG_OPERWALL;
  }
}
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1460 "ircd_parser.y"
    {
}
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1464 "ircd_parser.y"
    { not_atom = 1; }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1465 "ircd_parser.y"
    { not_atom = 0; }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1468 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)yy_aconf->port &= ~OPER_FLAG_GLOBAL_KILL;
    else yy_aconf->port |= OPER_FLAG_GLOBAL_KILL;
  }
}
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1475 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_REMOTE;
    else yy_aconf->port |= OPER_FLAG_REMOTE;
  }
}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1482 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_K;
    else yy_aconf->port |= OPER_FLAG_K;
  }
}
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1489 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_UNKLINE;
    else yy_aconf->port |= OPER_FLAG_UNKLINE;
  } 
}
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1496 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_X;
    else yy_aconf->port |= OPER_FLAG_X;
  }
}
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1503 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_GLINE;
    else yy_aconf->port |= OPER_FLAG_GLINE;
  }
}
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1510 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_DIE;
    else yy_aconf->port |= OPER_FLAG_DIE;
  }
}
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1517 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_REHASH;
    else yy_aconf->port |= OPER_FLAG_REHASH;
  }
}
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1524 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_ADMIN;
    else yy_aconf->port |= OPER_FLAG_ADMIN;
  }
}
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1531 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_HIDDEN_ADMIN;
    else yy_aconf->port |= OPER_FLAG_HIDDEN_ADMIN;
  }
}
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1538 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_N;
    else yy_aconf->port |= OPER_FLAG_N;
  }
}
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1545 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_OPERWALL;
    else yy_aconf->port |= OPER_FLAG_OPERWALL;
  }
}
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1552 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_OPER_SPY;
    else yy_aconf->port |= OPER_FLAG_OPER_SPY;
  }
}
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1559 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_HIDDEN_OPER;
    else yy_aconf->port |= OPER_FLAG_HIDDEN_OPER;
  }
}
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1566 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->port &= ~OPER_FLAG_REMOTEBAN;
    else yy_aconf->port |= OPER_FLAG_REMOTEBAN;
  }
}
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1573 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) ClearConfEncrypted(yy_aconf);
    else SetConfEncrypted(yy_aconf);
  }
}
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1586 "ircd_parser.y"
    {
  if (ypass == 1)
  {
    yy_conf = make_conf_item(CLASS_TYPE);
    yy_class = map_to_conf(yy_conf);
  }
}
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1593 "ircd_parser.y"
    {
  if (ypass == 1)
  {
    struct ConfItem *cconf = NULL;
    struct ClassItem *class = NULL;

    if (yy_class_name == NULL)
      delete_conf_item(yy_conf);
    else
    {
      cconf = find_exact_name_conf(CLASS_TYPE, yy_class_name, NULL, NULL, NULL);

      if (cconf != NULL)		/* The class existed already */
      {
        int user_count = 0;

        rebuild_cidr_class(cconf, yy_class);

        class = map_to_conf(cconf);

        user_count = class->curr_user_count;
        memcpy(class, yy_class, sizeof(*class));
        class->curr_user_count = user_count;
        class->active = 1;

        delete_conf_item(yy_conf);

        MyFree(cconf->name);            /* Allows case change of class name */
        cconf->name = yy_class_name;
        if(class->reject_message == NULL)
          DupString(class->reject_message, DEFAULT_CLASS_REJECT_MESSAGE);
      }
      else	/* Brand new class */
      {
        MyFree(yy_conf->name);          /* just in case it was allocated */
        if(yy_class->reject_message == NULL)
          DupString(yy_class->reject_message, DEFAULT_CLASS_REJECT_MESSAGE);
        yy_conf->name = yy_class_name;
        yy_class->active = 1;
      }
    }

    yy_class_name = NULL;
  }
}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1658 "ircd_parser.y"
    {
  if (ypass == 1)
  {
    MyFree(yy_class_name);
    DupString(yy_class_name, yylval.string);
  }
}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1667 "ircd_parser.y"
    {
  if (ypass == 1)
  {
    MyFree(yy_class_name);
    DupString(yy_class_name, yylval.string);
  }
}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1676 "ircd_parser.y"
    {
  if (ypass == 1)
    PingFreq(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1682 "ircd_parser.y"
    {
  if (ypass == 1)
    PingWarning(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1688 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxPerIp(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1694 "ircd_parser.y"
    {
  if (ypass == 1)
    ConFreq(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1700 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxTotal(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1706 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxGlobal(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1712 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxLocal(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1718 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxIdent(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1724 "ircd_parser.y"
    {
  if (ypass == 1)
    MaxSendq(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1730 "ircd_parser.y"
    {
  if (ypass == 1)
    CidrBitlenIPV4(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1736 "ircd_parser.y"
    {
  if (ypass == 1)
    CidrBitlenIPV6(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1742 "ircd_parser.y"
    {
  if (ypass == 1)
    NumberPerCidr(yy_class) = (yyvsp[(3) - (4)].number);
}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1748 "ircd_parser.y"
    {
  if (ypass == 1)
  {
    MyFree(yy_class->reject_message);
    DupString(yy_class->reject_message, yylval.string);
  }
}
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1760 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    listener_address = NULL;
    listener_flags = 0;
  }
}
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1767 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(listener_address);
    listener_address = NULL;
  }
}
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1776 "ircd_parser.y"
    {
  listener_flags = 0;
}
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1782 "ircd_parser.y"
    {
  if (ypass == 2)
    listener_flags |= LISTENER_SSL;
}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1786 "ircd_parser.y"
    {
  if (ypass == 2)
    listener_flags |= LISTENER_HIDDEN;
}
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1790 "ircd_parser.y"
    {
  if (ypass == 2)
    listener_flags |= LISTENER_SERVER;
}
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1800 "ircd_parser.y"
    { listener_flags = 0; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1805 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if ((listener_flags & LISTENER_SSL))
#ifdef HAVE_LIBCRYPTO
      if (!ServerInfo.ctx)
#endif
      {
        yyerror("SSL not available - port closed");
	break;
      }
    add_listener((yyvsp[(1) - (1)].number), listener_address, listener_flags);
  }
}
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1819 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    int i;

    if ((listener_flags & LISTENER_SSL))
#ifdef HAVE_LIBCRYPTO
      if (!ServerInfo.ctx)
#endif
      {
        yyerror("SSL not available - port closed");
	break;
      }

    for (i = (yyvsp[(1) - (3)].number); i <= (yyvsp[(3) - (3)].number); ++i)
      add_listener(i, listener_address, listener_flags);
  }
}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1839 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(listener_address);
    DupString(listener_address, yylval.string);
  }
}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1848 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(listener_address);
    DupString(listener_address, yylval.string);
  }
}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1860 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(CLIENT_TYPE);
    yy_aconf = map_to_conf(yy_conf);
  }
  else
  {
    MyFree(class_name);
    class_name = NULL;
  }
}
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1872 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp = NULL;
    dlink_node *ptr = NULL, *next_ptr = NULL;

    if (yy_aconf->user && yy_aconf->host)
    {
      conf_add_class_to_conf(yy_conf, class_name);
      add_conf_by_address(CONF_CLIENT, yy_aconf);
    }
    else
      delete_conf_item(yy_conf);

    /* copy over settings from first struct */
    DLINK_FOREACH_SAFE(ptr, next_ptr, col_conf_list.head)
    {
      struct AccessItem *new_aconf;
      struct ConfItem *new_conf;

      new_conf = make_conf_item(CLIENT_TYPE);
      new_aconf = map_to_conf(new_conf);

      yy_tmp = ptr->data;

      assert(yy_tmp->user && yy_tmp->host);

      if (yy_aconf->passwd != NULL)
        DupString(new_aconf->passwd, yy_aconf->passwd);
      if (yy_conf->name != NULL)
        DupString(new_conf->name, yy_conf->name);
      if (yy_aconf->passwd != NULL)
        DupString(new_aconf->passwd, yy_aconf->passwd);

      new_aconf->flags = yy_aconf->flags;
      new_aconf->port  = yy_aconf->port;

      DupString(new_aconf->user, yy_tmp->user);
      collapse(new_aconf->user);

      DupString(new_aconf->host, yy_tmp->host);
      collapse(new_aconf->host);

      if (yy_aconf->certfp != NULL)
      {
        new_aconf->certfp = MyMalloc(SHA_DIGEST_LENGTH);
        memcpy(new_aconf->certfp, yy_aconf->certfp, SHA_DIGEST_LENGTH);
      }

      conf_add_class_to_conf(new_conf, class_name);
      add_conf_by_address(CONF_CLIENT, new_aconf);
      dlinkDelete(&yy_tmp->node, &col_conf_list);
      free_collect_item(yy_tmp);
    }

    MyFree(class_name);
    class_name = NULL;
    yy_conf = NULL;
    yy_aconf = NULL;
  }
}
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1943 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = userbuf;
    nuh.hostptr  = hostbuf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(userbuf);
    nuh.hostsize = sizeof(hostbuf);

    split_nuh(&nuh);

    if (yy_aconf->user == NULL)
    {
      DupString(yy_aconf->user, userbuf);
      DupString(yy_aconf->host, hostbuf);
    }
    else
    {
      yy_tmp = MyMalloc(sizeof(struct CollectItem));

      DupString(yy_tmp->user, userbuf);
      DupString(yy_tmp->host, hostbuf);

      dlinkAdd(yy_tmp, &yy_tmp->node, &col_conf_list);
    }
  }
}
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1980 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    /* be paranoid */
    if (yy_aconf->passwd != NULL)
      memset(yy_aconf->passwd, 0, strlen(yy_aconf->passwd));

    MyFree(yy_aconf->passwd);
    DupString(yy_aconf->passwd, yylval.string);
  }
}
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1993 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    char tmp[SHA_DIGEST_LENGTH];

    if(yy_aconf->certfp != NULL)
      MyFree(yy_aconf->certfp);

    if(base16_decode(tmp, SHA_DIGEST_LENGTH, yylval.string, strlen(yylval.string)) != 0)
    {
      yyerror("Invalid client certificate fingerprint provided. Ignoring");
      break;
    }
    yy_aconf->certfp = MyMalloc(SHA_DIGEST_LENGTH);
    memcpy(yy_aconf->certfp, tmp, SHA_DIGEST_LENGTH);
  }
}
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 2013 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_SPOOF_NOTICE;
    else
      yy_aconf->flags &= ~CONF_FLAGS_SPOOF_NOTICE;
  }
}
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 2024 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(class_name);
    DupString(class_name, yylval.string);
  }
}
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 2033 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      SetConfEncrypted(yy_aconf);
    else
      ClearConfEncrypted(yy_aconf);
  }
}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 2044 "ircd_parser.y"
    {
}
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 2048 "ircd_parser.y"
    { not_atom = 1; }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 2049 "ircd_parser.y"
    { not_atom = 0; }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 2052 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_SPOOF_NOTICE;
    else yy_aconf->flags |= CONF_FLAGS_SPOOF_NOTICE;
  }

}
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 2060 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_NOLIMIT;
    else yy_aconf->flags |= CONF_FLAGS_NOLIMIT;
  }
}
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 2067 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_EXEMPTKLINE;
    else yy_aconf->flags |= CONF_FLAGS_EXEMPTKLINE;
  } 
}
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 2074 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_NEED_IDENTD;
    else yy_aconf->flags |= CONF_FLAGS_NEED_IDENTD;
  }
}
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 2081 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_CAN_FLOOD;
    else yy_aconf->flags |= CONF_FLAGS_CAN_FLOOD;
  }
}
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 2088 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_IDLE_LINED;
    else yy_aconf->flags |= CONF_FLAGS_IDLE_LINED;
  }
}
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 2095 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_NO_TILDE;
    else yy_aconf->flags |= CONF_FLAGS_NO_TILDE;
  } 
}
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 2102 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_EXEMPTGLINE;
    else yy_aconf->flags |= CONF_FLAGS_EXEMPTGLINE;
  } 
}
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 2109 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_EXEMPTRESV;
    else yy_aconf->flags |= CONF_FLAGS_EXEMPTRESV;
  }
}
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 2116 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom) yy_aconf->flags &= ~CONF_FLAGS_NEED_PASSWORD;
    else yy_aconf->flags |= CONF_FLAGS_NEED_PASSWORD;
  }
}
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 2125 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_EXEMPTKLINE;
    else
      yy_aconf->flags &= ~CONF_FLAGS_EXEMPTKLINE;
  }
}
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 2136 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_NEED_IDENTD;
    else
      yy_aconf->flags &= ~CONF_FLAGS_NEED_IDENTD;
  }
}
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 2147 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_NOLIMIT;
    else
      yy_aconf->flags &= ~CONF_FLAGS_NOLIMIT;
  }
}
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 2158 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_CAN_FLOOD;
    else
      yy_aconf->flags &= ~CONF_FLAGS_CAN_FLOOD;
  }
}
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 2169 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_NO_TILDE;
    else
      yy_aconf->flags &= ~CONF_FLAGS_NO_TILDE;
  }
}
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 2180 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_EXEMPTGLINE;
    else
      yy_aconf->flags &= ~CONF_FLAGS_EXEMPTGLINE;
  }
}
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 2192 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_conf->name);

    if (strlen(yylval.string) < HOSTLEN)
    {    
      DupString(yy_conf->name, yylval.string);
      yy_aconf->flags |= CONF_FLAGS_SPOOF_IP;
    }
    else
    {
      ilog(L_ERROR, "Spoofs must be less than %d..ignoring it", HOSTLEN);
      yy_conf->name = NULL;
    }
  }
}
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 2211 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_aconf->flags |= CONF_FLAGS_REDIR;
    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 2221 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_aconf->flags |= CONF_FLAGS_REDIR;
    yy_aconf->port = (yyvsp[(3) - (4)].number);
  }
}
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 2230 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_NEED_PASSWORD;
    else
      yy_aconf->flags &= ~CONF_FLAGS_NEED_PASSWORD;
  }
}
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 2245 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(resv_reason);
    resv_reason = NULL;
  }
}
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 2252 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(resv_reason);
    resv_reason = NULL;
  }
}
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2264 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(resv_reason);
    DupString(resv_reason, yylval.string);
  }
}
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2273 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (IsChanPrefix(*yylval.string))
    {
      char def_reason[] = "No reason";

      create_channel_resv(yylval.string, resv_reason != NULL ? resv_reason : def_reason, 1);
    }
  }
  /* ignore it for now.. but we really should make a warning if
   * its an erroneous name --fl_ */
}
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2288 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    char def_reason[] = "No reason";

    create_nick_resv(yylval.string, resv_reason != NULL ? resv_reason : def_reason, 1);
  }
}
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2301 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(ULINE_TYPE);
    yy_match_item = map_to_conf(yy_conf);
    yy_match_item->action = SHARED_ALL;
  }
}
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2309 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = NULL;
  }
}
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2320 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2329 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = userbuf;
    nuh.hostptr  = hostbuf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(userbuf);
    nuh.hostsize = sizeof(hostbuf);

    split_nuh(&nuh);

    DupString(yy_match_item->user, userbuf);
    DupString(yy_match_item->host, hostbuf);
  }
}
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2351 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action = 0;
}
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2358 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_KLINE;
}
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2362 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_TKLINE;
}
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2366 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_UNKLINE;
}
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2370 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_XLINE;
}
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2374 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_TXLINE;
}
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2378 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_UNXLINE;
}
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2382 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_RESV;
}
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2386 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_TRESV;
}
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2390 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_UNRESV;
}
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2394 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action |= SHARED_LOCOPS;
}
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 2398 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_match_item->action = SHARED_ALL;
}
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2407 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(CLUSTER_TYPE);
    yy_conf->flags = SHARED_ALL;
  }
}
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2414 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yy_conf->name == NULL)
      DupString(yy_conf->name, "*");
    yy_conf = NULL;
  }
}
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2427 "ircd_parser.y"
    {
  if (ypass == 2)
    DupString(yy_conf->name, yylval.string);
}
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2433 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags = 0;
}
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2440 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_KLINE;
}
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2444 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_TKLINE;
}
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2448 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_UNKLINE;
}
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2452 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_XLINE;
}
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2456 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_TXLINE;
}
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2460 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_UNXLINE;
}
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2464 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_RESV;
}
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2468 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_TRESV;
}
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2472 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_UNRESV;
}
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2476 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags |= SHARED_LOCOPS;
}
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2480 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_conf->flags = SHARED_ALL;
}
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2489 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(SERVER_TYPE);
    yy_aconf = (struct AccessItem *)map_to_conf(yy_conf);
    yy_aconf->passwd = NULL;
    /* defaults */
    yy_aconf->port = PORTNUM;

    if (ConfigFileEntry.burst_away)
      yy_aconf->flags = CONF_FLAGS_BURST_AWAY;
  }
  else
  {
    MyFree(class_name);
    class_name = NULL;
  }
}
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2507 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_hconf=NULL;
    struct CollectItem *yy_lconf=NULL;
    dlink_node *ptr;
    dlink_node *next_ptr;
#ifdef HAVE_LIBCRYPTO
    if (yy_aconf->host &&
	((yy_aconf->passwd && yy_aconf->spasswd) ||
	 (yy_aconf->rsa_public_key && IsConfCryptLink(yy_aconf))))
#else /* !HAVE_LIBCRYPTO */
      if (yy_aconf->host && !IsConfCryptLink(yy_aconf) && 
	  yy_aconf->passwd && yy_aconf->spasswd)
#endif /* !HAVE_LIBCRYPTO */
	{
	  if (conf_add_server(yy_conf, class_name) == -1)
	  {
	    delete_conf_item(yy_conf);
	    yy_conf = NULL;
	    yy_aconf = NULL;
	  }
	}
	else
	{
	  /* Even if yy_conf ->name is NULL
	   * should still unhook any hub/leaf confs still pending
	   */
	  unhook_hub_leaf_confs();

	  if (yy_conf->name != NULL)
	  {
#ifndef HAVE_LIBCRYPTO
	    if (IsConfCryptLink(yy_aconf))
	      yyerror("Ignoring connect block -- no OpenSSL support");
#else
	    if (IsConfCryptLink(yy_aconf) && !yy_aconf->rsa_public_key)
	      yyerror("Ignoring connect block -- missing key");
#endif
	    if (yy_aconf->host == NULL)
	      yyerror("Ignoring connect block -- missing host");
	    else if (!IsConfCryptLink(yy_aconf) && 
		    (!yy_aconf->passwd || !yy_aconf->spasswd))
              yyerror("Ignoring connect block -- missing password");
	  }


          /* XXX
           * This fixes a try_connections() core (caused by invalid class_ptr
           * pointers) reported by metalrock. That's an ugly fix, but there
           * is currently no better way. The entire config subsystem needs an
           * rewrite ASAP. make_conf_item() shouldn't really add things onto
           * a doubly linked list immediately without any sanity checks!  -Michael
           */
          delete_conf_item(yy_conf);

          yy_aconf = NULL;
	  yy_conf = NULL;
	}

      /*
       * yy_conf is still pointing at the server that is having
       * a connect block built for it. This means, y_aconf->name 
       * points to the actual irc name this server will be known as.
       * Now this new server has a set or even just one hub_mask (or leaf_mask)
       * given in the link list at yy_hconf. Fill in the HUB confs
       * from this link list now.
       */        
      DLINK_FOREACH_SAFE(ptr, next_ptr, hub_conf_list.head)
      {
	struct ConfItem *new_hub_conf;
	struct MatchItem *match_item;

	yy_hconf = ptr->data;

	/* yy_conf == NULL is a fatal error for this connect block! */
	if ((yy_conf != NULL) && (yy_conf->name != NULL))
	{
	  new_hub_conf = make_conf_item(HUB_TYPE);
	  match_item = (struct MatchItem *)map_to_conf(new_hub_conf);
	  DupString(new_hub_conf->name, yy_conf->name);
	  if (yy_hconf->user != NULL)
	    DupString(match_item->user, yy_hconf->user);
	  else
	    DupString(match_item->user, "*");
	  if (yy_hconf->host != NULL)
	    DupString(match_item->host, yy_hconf->host);
	  else
	    DupString(match_item->host, "*");
	}
	dlinkDelete(&yy_hconf->node, &hub_conf_list);
	free_collect_item(yy_hconf);
      }

      /* Ditto for the LEAF confs */

      DLINK_FOREACH_SAFE(ptr, next_ptr, leaf_conf_list.head)
      {
	struct ConfItem *new_leaf_conf;
	struct MatchItem *match_item;

	yy_lconf = ptr->data;

	if ((yy_conf != NULL) && (yy_conf->name != NULL))
	{
	  new_leaf_conf = make_conf_item(LEAF_TYPE);
	  match_item = (struct MatchItem *)map_to_conf(new_leaf_conf);
	  DupString(new_leaf_conf->name, yy_conf->name);
	  if (yy_lconf->user != NULL)
	    DupString(match_item->user, yy_lconf->user);
	  else
	    DupString(match_item->user, "*");
	  if (yy_lconf->host != NULL)
	    DupString(match_item->host, yy_lconf->host);
	  else
	    DupString(match_item->host, "*");
	}
	dlinkDelete(&yy_lconf->node, &leaf_conf_list);
	free_collect_item(yy_lconf);
      }
      MyFree(class_name);
      class_name = NULL;
      yy_conf = NULL;
      yy_aconf = NULL;
  }
}
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2646 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yy_conf->name != NULL)
      yyerror("Multiple connect name entry");

    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2658 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yy_conf->name != NULL)
      yyerror("Multiple connect name entry");

    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2670 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_aconf->host);
    DupString(yy_aconf->host, yylval.string);
  }
}
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2679 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (irc_getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(L_ERROR, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&yy_aconf->my_ipnum, res->ai_addr, res->ai_addrlen);
      yy_aconf->my_ipnum.ss.ss_family = res->ai_family;
      yy_aconf->my_ipnum.ss_len = res->ai_addrlen;
      irc_freeaddrinfo(res);
    }
  }
}
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2705 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if ((yyvsp[(3) - (4)].string)[0] == ':')
      yyerror("Server passwords cannot begin with a colon");
    else if (strchr((yyvsp[(3) - (4)].string), ' ') != NULL)
      yyerror("Server passwords cannot contain spaces");
    else {
      if (yy_aconf->spasswd != NULL)
        memset(yy_aconf->spasswd, 0, strlen(yy_aconf->spasswd));

      MyFree(yy_aconf->spasswd);
      DupString(yy_aconf->spasswd, yylval.string);
    }
  }
}
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2723 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if ((yyvsp[(3) - (4)].string)[0] == ':')
      yyerror("Server passwords cannot begin with a colon");
    else if (strchr((yyvsp[(3) - (4)].string), ' ') != NULL)
      yyerror("Server passwords cannot contain spaces");
    else {
      if (yy_aconf->passwd != NULL)
        memset(yy_aconf->passwd, 0, strlen(yy_aconf->passwd));

      MyFree(yy_aconf->passwd);
      DupString(yy_aconf->passwd, yylval.string);
    }
  }
}
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2741 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->port = (yyvsp[(3) - (4)].number);
}
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2747 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->aftype = AF_INET;
}
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2751 "ircd_parser.y"
    {
#ifdef IPV6
  if (ypass == 2)
    yy_aconf->aftype = AF_INET6;
#endif
}
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2759 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_aconf->fakename);
    DupString(yy_aconf->fakename, yylval.string);
  }
}
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2768 "ircd_parser.y"
    {
}
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2772 "ircd_parser.y"
    { not_atom = 1; }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2773 "ircd_parser.y"
    { not_atom = 0; }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2776 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)ClearConfLazyLink(yy_aconf);
    else SetConfLazyLink(yy_aconf);
  }
}
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2783 "ircd_parser.y"
    {
  if (ypass == 2)
#ifndef HAVE_LIBZ
    yyerror("Ignoring flags = compressed; -- no zlib support");
#else
 {
   if (not_atom)ClearConfCompressed(yy_aconf);
   else SetConfCompressed(yy_aconf);
 }
#endif
}
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2794 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)ClearConfCryptLink(yy_aconf);
    else SetConfCryptLink(yy_aconf);
  }
}
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2801 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)ClearConfAllowAutoConn(yy_aconf);
    else SetConfAllowAutoConn(yy_aconf);
  }
}
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2808 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)ClearConfAwayBurst(yy_aconf);
    else SetConfAwayBurst(yy_aconf);
  }
}
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2815 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (not_atom)ClearConfTopicBurst(yy_aconf);
    else SetConfTopicBurst(yy_aconf);
  }
}
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2825 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 2)
  {
    BIO *file;

    if (yy_aconf->rsa_public_key != NULL)
    {
      RSA_free(yy_aconf->rsa_public_key);
      yy_aconf->rsa_public_key = NULL;
    }

    if (yy_aconf->rsa_public_key_file != NULL)
    {
      MyFree(yy_aconf->rsa_public_key_file);
      yy_aconf->rsa_public_key_file = NULL;
    }

    DupString(yy_aconf->rsa_public_key_file, yylval.string);

    if ((file = BIO_new_file(yylval.string, "r")) == NULL)
    {
      yyerror("Ignoring rsa_public_key_file -- file doesn't exist");
      break;
    }

    yy_aconf->rsa_public_key = (RSA *)PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL);

    if (yy_aconf->rsa_public_key == NULL)
    {
      yyerror("Ignoring rsa_public_key_file -- Key invalid; check key syntax.");
      break;
    }
      
    (void)BIO_set_close(file, BIO_CLOSE);
    BIO_free(file);
  }
#endif /* HAVE_LIBCRYPTO */
}
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2866 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_ENCRYPTED;
    else
      yy_aconf->flags &= ~CONF_FLAGS_ENCRYPTED;
  }
}
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2877 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_CRYPTLINK;
    else
      yy_aconf->flags &= ~CONF_FLAGS_CRYPTLINK;
  }
}
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2888 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
#ifndef HAVE_LIBZ
      yyerror("Ignoring compressed=yes; -- no zlib support");
#else
      yy_aconf->flags |= CONF_FLAGS_COMPRESSED;
#endif
    else
      yy_aconf->flags &= ~CONF_FLAGS_COMPRESSED;
  }
}
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2903 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      yy_aconf->flags |= CONF_FLAGS_ALLOW_AUTO_CONN;
    else
      yy_aconf->flags &= ~CONF_FLAGS_ALLOW_AUTO_CONN;
  }
}
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2914 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.number)
      SetConfTopicBurst(yy_aconf);
    else
      ClearConfTopicBurst(yy_aconf);
  }
}
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2925 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp;

    yy_tmp = (struct CollectItem *)MyMalloc(sizeof(struct CollectItem));
    DupString(yy_tmp->host, yylval.string);
    DupString(yy_tmp->user, "*");
    dlinkAdd(yy_tmp, &yy_tmp->node, &hub_conf_list);
  }
}
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2938 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp;

    yy_tmp = (struct CollectItem *)MyMalloc(sizeof(struct CollectItem));
    DupString(yy_tmp->host, yylval.string);
    DupString(yy_tmp->user, "*");
    dlinkAdd(yy_tmp, &yy_tmp->node, &leaf_conf_list);
  }
}
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2951 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(class_name);
    DupString(class_name, yylval.string);
  }
}
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2960 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 2)
  {
    struct EncCapability *ecap;
    const char *cipher_name;
    int found = 0;

    yy_aconf->cipher_preference = NULL;
    cipher_name = yylval.string;

    for (ecap = CipherTable; ecap->name; ecap++)
    {
      if ((irccmp(ecap->name, cipher_name) == 0) &&
          (ecap->cap & CAP_ENC_MASK))
      {
        yy_aconf->cipher_preference = ecap;
        found = 1;
        break;
      }
    }

    if (!found)
      yyerror("Invalid cipher");
  }
#else
  if (ypass == 2)
    yyerror("Ignoring cipher_preference -- no OpenSSL support");
#endif
}
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2995 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    userbuf[0] = hostbuf[0] = reasonbuf[0] = '\0';
    regex_ban = 0;
  }
}
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 3002 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (userbuf[0] && hostbuf[0])
    {
      if (regex_ban)
      {
        pcre *exp_user = NULL;
        pcre *exp_host = NULL;
        const char *errptr = NULL;

        if (!(exp_user = ircd_pcre_compile(userbuf, &errptr)) ||
            !(exp_host = ircd_pcre_compile(hostbuf, &errptr)))
        {
          ilog(L_ERROR, "Failed to add regular expression based K-Line: %s",
               errptr);
          break;
        }

        yy_conf = make_conf_item(RKLINE_TYPE);
        yy_aconf = map_to_conf(yy_conf);

        yy_aconf->regexuser = exp_user;
        yy_aconf->regexhost = exp_host;

        DupString(yy_aconf->user, userbuf);
        DupString(yy_aconf->host, hostbuf);

        if (reasonbuf[0])
          DupString(yy_aconf->reason, reasonbuf);
        else
          DupString(yy_aconf->reason, "No reason");
      }
      else
      {
        yy_conf = make_conf_item(KLINE_TYPE);
        yy_aconf = map_to_conf(yy_conf);

        DupString(yy_aconf->user, userbuf);
        DupString(yy_aconf->host, hostbuf);

        if (reasonbuf[0])
          DupString(yy_aconf->reason, reasonbuf);
        else
          DupString(yy_aconf->reason, "No reason");
        add_conf_by_address(CONF_KILL, yy_aconf);
      }
    }
    else
      delete_conf_item(yy_conf);

    yy_conf = NULL;
    yy_aconf = NULL;
  }
}
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 3059 "ircd_parser.y"
    {
}
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 3064 "ircd_parser.y"
    {
  if (ypass == 2)
    regex_ban = 1;
}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 3073 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = userbuf;
    nuh.hostptr  = hostbuf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(userbuf);
    nuh.hostsize = sizeof(hostbuf);

    split_nuh(&nuh);
  }
}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 3092 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(reasonbuf, yylval.string, sizeof(reasonbuf));
}
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 3101 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(DLINE_TYPE);
    yy_aconf = map_to_conf(yy_conf);
    /* default reason */
    DupString(yy_aconf->reason, "No reason");
  }
}
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 3110 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yy_aconf->host && parse_netmask(yy_aconf->host, NULL, NULL) != HM_HOST)
      add_conf_by_address(CONF_DLINE, yy_aconf);
    else
      delete_conf_item(yy_conf);
    yy_conf = NULL;
    yy_aconf = NULL;
  }
}
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 3126 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_aconf->host);
    DupString(yy_aconf->host, yylval.string);
  }
}
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 3135 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(yy_aconf->reason);
    DupString(yy_aconf->reason, yylval.string);
  }
}
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 3152 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      yy_conf = make_conf_item(EXEMPTDLINE_TYPE);
      yy_aconf = map_to_conf(yy_conf);
      DupString(yy_aconf->host, yylval.string);

      add_conf_by_address(CONF_EXEMPTDLINE, yy_aconf);

      yy_conf = NULL;
      yy_aconf = NULL;
    }
  }
}
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 3170 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    char tmp[SHA_DIGEST_LENGTH];

    yy_conf = make_conf_item(EXEMPTDLINE_TYPE);
    yy_aconf = map_to_conf(yy_conf);
  
    if(base16_decode(tmp, SHA_DIGEST_LENGTH, yylval.string, strlen(yylval.string)) != 0)
    {
      yyerror("Invalid client certificate fingerprint provided. Ignoring");
      break;
    }
 
    yy_aconf->certfp = MyMalloc(SHA_DIGEST_LENGTH);
    yy_aconf->host = MyMalloc(SHA_DIGEST_LENGTH);
    memcpy(yy_aconf->certfp, tmp, SHA_DIGEST_LENGTH);
    memcpy(yy_aconf->host, tmp, SHA_DIGEST_LENGTH);
 
    add_conf_by_address(CONF_EXEMPTDLINE, yy_aconf);

    yy_conf = NULL;
    yy_aconf = NULL;

 }
}
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 3202 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    regex_ban = 0;
    reasonbuf[0] = gecos_name[0] = '\0';
  }
}
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 3209 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (gecos_name[0])
    {
      if (regex_ban)
      {
        pcre *exp_p = NULL;
        const char *errptr = NULL;

        if (!(exp_p = ircd_pcre_compile(gecos_name, &errptr)))
        {
          ilog(L_ERROR, "Failed to add regular expression based X-Line: %s",
               errptr);
          break;
        }

        yy_conf = make_conf_item(RXLINE_TYPE);
        yy_conf->regexpname = exp_p;
      }
      else
        yy_conf = make_conf_item(XLINE_TYPE);

      yy_match_item = map_to_conf(yy_conf);
      DupString(yy_conf->name, gecos_name);

      if (reasonbuf[0])
        DupString(yy_match_item->reason, reasonbuf);
      else
        DupString(yy_match_item->reason, "No reason");
    }
  }
}
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 3244 "ircd_parser.y"
    {
}
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 3249 "ircd_parser.y"
    {
  if (ypass == 2)
    regex_ban = 1;
}
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 3258 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(gecos_name, yylval.string, sizeof(gecos_name));
}
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 3264 "ircd_parser.y"
    {
  if (ypass == 2)
    strlcpy(reasonbuf, yylval.string, sizeof(reasonbuf));
}
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 3310 "ircd_parser.y"
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[(3) - (4)].number);
}
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 3315 "ircd_parser.y"
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[(3) - (4)].number);
}
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 3320 "ircd_parser.y"
    {
  ConfigFileEntry.burst_away = yylval.number;
}
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 3325 "ircd_parser.y"
    {
  ConfigFileEntry.use_whois_actually = yylval.number;
}
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 3330 "ircd_parser.y"
    {
  GlobalSetOptions.rejecttime = yylval.number;
}
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 3335 "ircd_parser.y"
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 3340 "ircd_parser.y"
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[(3) - (4)].number);
}
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 3345 "ircd_parser.y"
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 3350 "ircd_parser.y"
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 3355 "ircd_parser.y"
    {
  ConfigFileEntry.disable_remote = yylval.number;
}
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 3360 "ircd_parser.y"
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 3365 "ircd_parser.y"
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 3370 "ircd_parser.y"
    {
  ConfigFileEntry.max_nick_time = (yyvsp[(3) - (4)].number); 
}
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 3375 "ircd_parser.y"
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[(3) - (4)].number);
}
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 3380 "ircd_parser.y"
    {
  ConfigFileEntry.max_accept = (yyvsp[(3) - (4)].number);
}
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 3385 "ircd_parser.y"
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[(3) - (4)].number);
}
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 3390 "ircd_parser.y"
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[(3) - (4)].number);
}
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 3395 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[(3) - (4)].number);
}
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 3401 "ircd_parser.y"
    {
  if (((yyvsp[(3) - (4)].number) > 0) && ypass == 1)
  {
    ilog(L_CRIT, "You haven't read your config file properly.");
    ilog(L_CRIT, "There is a line in the example conf that will kill your server if not removed.");
    ilog(L_CRIT, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 3412 "ircd_parser.y"
    {
  ConfigFileEntry.kline_with_reason = yylval.number;
}
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 3417 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    DupString(ConfigFileEntry.kline_reason, yylval.string);
  }
}
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 3426 "ircd_parser.y"
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 3431 "ircd_parser.y"
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 3436 "ircd_parser.y"
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 3441 "ircd_parser.y"
    {
  ConfigFileEntry.godmode_timeout = (yyvsp[(3) - (4)].number);
}
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 3446 "ircd_parser.y"
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 3451 "ircd_parser.y"
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 3456 "ircd_parser.y"
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 3459 "ircd_parser.y"
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 3464 "ircd_parser.y"
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 3467 "ircd_parser.y"
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 3472 "ircd_parser.y"
    {
  ConfigFileEntry.pace_wait = (yyvsp[(3) - (4)].number);
}
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 3477 "ircd_parser.y"
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[(3) - (4)].number);
}
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 3482 "ircd_parser.y"
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 3487 "ircd_parser.y"
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[(3) - (4)].number);
}
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 3492 "ircd_parser.y"
    {
  ConfigFileEntry.short_motd = yylval.number;
}
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 3497 "ircd_parser.y"
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 3502 "ircd_parser.y"
    {
  ConfigFileEntry.true_no_oper_flood = yylval.number;
}
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 3507 "ircd_parser.y"
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 3512 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (strlen(yylval.string) > LOCALE_LENGTH-2)
      yylval.string[LOCALE_LENGTH-1] = '\0';

    set_locale(yylval.string);
  }
}
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 3523 "ircd_parser.y"
    {
  ConfigFileEntry.idletime = (yyvsp[(3) - (4)].number);
}
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 3528 "ircd_parser.y"
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[(3) - (4)].number);
}
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 3533 "ircd_parser.y"
    {
  ConfigFileEntry.max_targets = (yyvsp[(3) - (4)].number);
}
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 3538 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ConfigFileEntry.servlink_path);
    DupString(ConfigFileEntry.servlink_path, yylval.string);
  }
}
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 3547 "ircd_parser.y"
    {
#ifdef HAVE_LIBCRYPTO
  if (ypass == 2)
  {
    struct EncCapability *ecap;
    const char *cipher_name;
    int found = 0;

    ConfigFileEntry.default_cipher_preference = NULL;
    cipher_name = yylval.string;

    for (ecap = CipherTable; ecap->name; ecap++)
    {
      if ((irccmp(ecap->name, cipher_name) == 0) &&
          (ecap->cap & CAP_ENC_MASK))
      {
        ConfigFileEntry.default_cipher_preference = ecap;
        found = 1;
        break;
      }
    }

    if (!found)
      yyerror("Invalid cipher");
  }
#else
  if (ypass == 2)
    yyerror("Ignoring default_cipher_preference -- no OpenSSL support");
#endif
}
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 3579 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    ConfigFileEntry.compression_level = (yyvsp[(3) - (4)].number);
#ifndef HAVE_LIBZ
    yyerror("Ignoring compression_level -- no zlib support");
#else
    if ((ConfigFileEntry.compression_level < 1) ||
        (ConfigFileEntry.compression_level > 9))
    {
      yyerror("Ignoring invalid compression_level, using default");
      ConfigFileEntry.compression_level = 0;
    }
#endif
  }
}
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 3597 "ircd_parser.y"
    {
  ConfigFileEntry.use_egd = yylval.number;
}
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 3602 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ConfigFileEntry.egdpool_path);
    DupString(ConfigFileEntry.egdpool_path, yylval.string);
  }
}
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 3611 "ircd_parser.y"
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 3616 "ircd_parser.y"
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 3621 "ircd_parser.y"
    {
  ConfigFileEntry.throttle_time = yylval.number;
}
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 3626 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes = 0;
}
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 3632 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_BOTS;
}
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 3635 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_CCONN;
}
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 3638 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_CCONN_FULL;
}
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 3641 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 3644 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEBUG;
}
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 3647 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_FULL;
}
    break;

  case 621:
/* Line 1792 of yacc.c  */
#line 3650 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_SKILL;
}
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 3653 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_NCHANGE;
}
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 3656 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_REJ;
}
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 3659 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_UNAUTH;
}
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 3662 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 3665 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_EXTERNAL;
}
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 3668 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 3671 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 3674 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 3677 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 3680 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 3683 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 3686 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 3689 "ircd_parser.y"
    {
  ConfigFileEntry.oper_umodes |= UMODE_GOD;
}
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 3694 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 3700 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_BOTS;
}
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 3703 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CCONN;
}
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 3706 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CCONN_FULL;
}
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 3709 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 3712 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEBUG;
}
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 3715 "ircd_parser.y"
    { 
  ConfigFileEntry.oper_only_umodes |= UMODE_FULL;
}
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 3718 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SKILL;
}
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 3721 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NCHANGE;
}
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 3724 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REJ;
}
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 3727 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_UNAUTH;
}
    break;

  case 649:
/* Line 1792 of yacc.c  */
#line 3730 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 3733 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_EXTERNAL;
}
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 3736 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 3739 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 3742 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 3745 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 3748 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 3751 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 3754 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 3757 "ircd_parser.y"
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_GOD;
}
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 3762 "ircd_parser.y"
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[(3) - (4)].number);
}
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 3767 "ircd_parser.y"
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[(3) - (4)].number);
}
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 3772 "ircd_parser.y"
    {
  ConfigFileEntry.default_floodcount = (yyvsp[(3) - (4)].number);
}
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 3777 "ircd_parser.y"
    {
  ConfigFileEntry.client_flood = (yyvsp[(3) - (4)].number);
}
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 3782 "ircd_parser.y"
    {
  ConfigFileEntry.dot_in_ip6_addr = yylval.number;
}
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 3790 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    yy_conf = make_conf_item(GDENY_TYPE);
    yy_aconf = map_to_conf(yy_conf);
  }
}
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 3797 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    /*
     * since we re-allocate yy_conf/yy_aconf after the end of action=, at the
     * end we will have one extra, so we should free it.
     */
    if (yy_conf->name == NULL || yy_aconf->user == NULL)
    {
      delete_conf_item(yy_conf);
      yy_conf = NULL;
      yy_aconf = NULL;
    }
  }
}
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 3823 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.glines = yylval.number;
}
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 3829 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.gline_time = (yyvsp[(3) - (4)].number);
}
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 3835 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.gline_logging = 0;
}
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 3841 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.gline_logging |= GDENY_REJECT;
}
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 3845 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigFileEntry.gline_logging |= GDENY_BLOCK;
}
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 3851 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = userbuf;
    nuh.hostptr  = hostbuf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(userbuf);
    nuh.hostsize = sizeof(hostbuf);

    split_nuh(&nuh);

    if (yy_aconf->user == NULL)
    {
      DupString(yy_aconf->user, userbuf);
      DupString(yy_aconf->host, hostbuf);
    }
    else
    {
      struct CollectItem *yy_tmp = MyMalloc(sizeof(struct CollectItem));

      DupString(yy_tmp->user, userbuf);
      DupString(yy_tmp->host, hostbuf);

      dlinkAdd(yy_tmp, &yy_tmp->node, &col_conf_list);
    }
  }
}
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 3885 "ircd_parser.y"
    {
  if (ypass == 2)  
  {
    MyFree(yy_conf->name);
    DupString(yy_conf->name, yylval.string);
  }
}
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 3894 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->flags = 0;
}
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 3898 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    struct CollectItem *yy_tmp = NULL;
    dlink_node *ptr, *next_ptr;

    DLINK_FOREACH_SAFE(ptr, next_ptr, col_conf_list.head)
    {
      struct AccessItem *new_aconf;
      struct ConfItem *new_conf;

      yy_tmp = ptr->data;
      new_conf = make_conf_item(GDENY_TYPE);
      new_aconf = map_to_conf(new_conf);

      new_aconf->flags = yy_aconf->flags;

      if (yy_conf->name != NULL)
        DupString(new_conf->name, yy_conf->name);
      else
        DupString(new_conf->name, "*");
      if (yy_aconf->user != NULL)
         DupString(new_aconf->user, yy_tmp->user);
      else   
        DupString(new_aconf->user, "*");
      if (yy_aconf->host != NULL)
        DupString(new_aconf->host, yy_tmp->host);
      else
        DupString(new_aconf->host, "*");

      dlinkDelete(&yy_tmp->node, &col_conf_list);
    }

    /*
     * In case someone has fed us with more than one action= after user/name
     * which would leak memory  -Michael
     */
    if (yy_conf->name == NULL || yy_aconf->user == NULL)
      delete_conf_item(yy_conf);

    yy_conf = make_conf_item(GDENY_TYPE);
    yy_aconf = map_to_conf(yy_conf);
  }
}
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 3945 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->flags |= GDENY_REJECT;
}
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 3949 "ircd_parser.y"
    {
  if (ypass == 2)
    yy_aconf->flags |= GDENY_BLOCK;
}
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 3973 "ircd_parser.y"
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 3978 "ircd_parser.y"
    {
  ConfigChannel.restrict_channels = yylval.number;
}
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 3983 "ircd_parser.y"
    {
  ConfigChannel.disable_local_channels = yylval.number;
}
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 3988 "ircd_parser.y"
    {
  ConfigChannel.use_except = yylval.number;
}
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 3993 "ircd_parser.y"
    {
  ConfigChannel.use_invex = yylval.number;
}
    break;

  case 719:
/* Line 1792 of yacc.c  */
#line 3998 "ircd_parser.y"
    {
  ConfigChannel.use_quiet = yylval.number;
}
    break;

  case 720:
/* Line 1792 of yacc.c  */
#line 4003 "ircd_parser.y"
    {
  ConfigChannel.use_knock = yylval.number;
}
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 4008 "ircd_parser.y"
    {
  ConfigChannel.knock_delay = (yyvsp[(3) - (4)].number);
}
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 4013 "ircd_parser.y"
    {
  ConfigChannel.knock_delay_channel = (yyvsp[(3) - (4)].number);
}
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 4018 "ircd_parser.y"
    {
  ConfigChannel.max_chans_per_user = (yyvsp[(3) - (4)].number);
}
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 4023 "ircd_parser.y"
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 4028 "ircd_parser.y"
    {
  ConfigChannel.max_bans = (yyvsp[(3) - (4)].number);
}
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 4033 "ircd_parser.y"
    {
  ConfigChannel.default_split_user_count = (yyvsp[(3) - (4)].number);
}
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 4038 "ircd_parser.y"
    {
  ConfigChannel.default_split_server_count = (yyvsp[(3) - (4)].number);
}
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 4043 "ircd_parser.y"
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 4048 "ircd_parser.y"
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 4053 "ircd_parser.y"
    {
  ConfigChannel.burst_topicwho = yylval.number;
}
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 4058 "ircd_parser.y"
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 4063 "ircd_parser.y"
    {
  GlobalSetOptions.joinfloodtime = yylval.number;
}
    break;

  case 744:
/* Line 1792 of yacc.c  */
#line 4082 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 4088 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 4094 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    DupString(ConfigServerHide.hidden_name, yylval.string);
  }
}
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 4103 "ircd_parser.y"
    {
  if (ypass == 2)
  {
    if (((yyvsp[(3) - (4)].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[(3) - (4)].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[(3) - (4)].number);
  }
}
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 4117 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigServerHide.hidden = yylval.number;
}
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 4123 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigServerHide.disable_hidden = yylval.number;
}
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 4129 "ircd_parser.y"
    {
  if (ypass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
    break;


/* Line 1792 of yacc.c  */
#line 8404 "ircd_parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


